// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// THIS FILE IS AUTOGENERATED. DO NOT EDIT.
// Generated by
//  content/browser/devtools/protocol/devtools_protocol_handler_generator.py
//  from gen/blink/core/inspector/protocol.json

#include "base/bind.h"
#include "base/strings/string_number_conversions.h"
#include "base/strings/string_split.h"
#include "content/browser/devtools/protocol/dom_handler.h"
#include "content/browser/devtools/protocol/emulation_handler.h"
#include "content/browser/devtools/protocol/input_handler.h"
#include "content/browser/devtools/protocol/inspector_handler.h"
#include "content/browser/devtools/protocol/io_handler.h"
#include "content/browser/devtools/protocol/memory_handler.h"
#include "content/browser/devtools/protocol/network_handler.h"
#include "content/browser/devtools/protocol/page_handler.h"
#include "content/browser/devtools/protocol/schema_handler.h"
#include "content/browser/devtools/protocol/security_handler.h"
#include "content/browser/devtools/protocol/service_worker_handler.h"
#include "content/browser/devtools/protocol/storage_handler.h"
#include "content/browser/devtools/protocol/system_info_handler.h"
#include "content/browser/devtools/protocol/target_handler.h"
#include "content/browser/devtools/protocol/tethering_handler.h"
#include "content/browser/devtools/protocol/tracing_handler.h"

namespace content {

DevToolsProtocolDispatcher::DevToolsProtocolDispatcher(
    DevToolsProtocolDelegate* notifier)
    : notifier_(notifier),
      client_(notifier),
      inspector_handler_(nullptr),
      memory_handler_(nullptr),
      page_handler_(nullptr),
      emulation_handler_(nullptr),
      security_handler_(nullptr),
      network_handler_(nullptr),
      dom_handler_(nullptr),
      io_handler_(nullptr),
      target_handler_(nullptr),
      service_worker_handler_(nullptr),
      input_handler_(nullptr),
      tracing_handler_(nullptr),
      storage_handler_(nullptr),
      system_info_handler_(nullptr),
      tethering_handler_(nullptr),
      schema_handler_(nullptr) {
}

DevToolsProtocolDispatcher::~DevToolsProtocolDispatcher() {
}

DevToolsProtocolDispatcher::CommandHandler
DevToolsProtocolDispatcher::FindCommandHandler(const std::string& method) {
  CommandHandlers::iterator it = command_handlers_.find(method);
  return it == command_handlers_.end() ? CommandHandler() : it->second;
}

bool DevToolsProtocolDispatcher::OnInspectorEnable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = inspector_handler_->Enable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnInspectorDisable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = inspector_handler_->Disable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnMemoryGetDOMCounters(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int out_documents = 0;
  int out_nodes = 0;
  int out_js_event_listeners = 0;
  Response response = memory_handler_->GetDOMCounters(
      &out_documents,
      &out_nodes,
      &out_js_event_listeners);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("documents", devtools::CreateValue(out_documents));
  result->Set("nodes", devtools::CreateValue(out_nodes));
  result->Set("jsEventListeners", devtools::CreateValue(out_js_event_listeners));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnMemorySetPressureNotificationsSuppressed(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_suppressed = false;
  if (!params || !params->GetBoolean("suppressed", &in_suppressed)) {
    client_.SendError(command_id, Response::InvalidParams("suppressed"));
    return true;
  }
  Response response = memory_handler_->SetPressureNotificationsSuppressed(
      in_suppressed);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnMemorySimulatePressureNotification(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_level;
  if (!params || !params->GetString("level", &in_level)) {
    client_.SendError(command_id, Response::InvalidParams("level"));
    return true;
  }
  Response response = memory_handler_->SimulatePressureNotification(
      in_level);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageEnable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = page_handler_->Enable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageDisable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = page_handler_->Disable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageAddScriptToEvaluateOnLoad(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_script_source;
  if (!params || !params->GetString("scriptSource", &in_script_source)) {
    client_.SendError(command_id, Response::InvalidParams("scriptSource"));
    return true;
  }
  std::string out_identifier;
  Response response = page_handler_->AddScriptToEvaluateOnLoad(
      in_script_source,
      &out_identifier);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("identifier", devtools::CreateValue(out_identifier));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageRemoveScriptToEvaluateOnLoad(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_identifier;
  if (!params || !params->GetString("identifier", &in_identifier)) {
    client_.SendError(command_id, Response::InvalidParams("identifier"));
    return true;
  }
  Response response = page_handler_->RemoveScriptToEvaluateOnLoad(
      in_identifier);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageSetAutoAttachToCreatedPages(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_auto_attach = false;
  if (!params || !params->GetBoolean("autoAttach", &in_auto_attach)) {
    client_.SendError(command_id, Response::InvalidParams("autoAttach"));
    return true;
  }
  Response response = page_handler_->SetAutoAttachToCreatedPages(
      in_auto_attach);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageReload(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_ignore_cache = false;
  bool ignore_cache_found = params && params->GetBoolean(
      "ignoreCache",
      &in_ignore_cache);
  std::string in_script_to_evaluate_on_load;
  bool script_to_evaluate_on_load_found = params && params->GetString(
      "scriptToEvaluateOnLoad",
      &in_script_to_evaluate_on_load);
  Response response = page_handler_->Reload(
      ignore_cache_found ? &in_ignore_cache : nullptr,
      script_to_evaluate_on_load_found ? &in_script_to_evaluate_on_load : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageNavigate(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_url;
  if (!params || !params->GetString("url", &in_url)) {
    client_.SendError(command_id, Response::InvalidParams("url"));
    return true;
  }
  std::string out_frame_id;
  Response response = page_handler_->Navigate(
      in_url,
      &out_frame_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("frameId", devtools::CreateValue(out_frame_id));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageGetNavigationHistory(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int out_current_index = 0;
  std::vector<scoped_refptr<devtools::page::NavigationEntry>> out_entries;
  Response response = page_handler_->GetNavigationHistory(
      &out_current_index,
      &out_entries);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("currentIndex", devtools::CreateValue(out_current_index));
  result->Set("entries", devtools::CreateValue(out_entries));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageNavigateToHistoryEntry(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_entry_id = 0;
  if (!params || !params->GetInteger("entryId", &in_entry_id)) {
    client_.SendError(command_id, Response::InvalidParams("entryId"));
    return true;
  }
  Response response = page_handler_->NavigateToHistoryEntry(
      in_entry_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageGetResourceTree(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  scoped_refptr<devtools::page::FrameResourceTree> out_frame_tree = nullptr;
  Response response = page_handler_->GetResourceTree(
      &out_frame_tree);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("frameTree", devtools::CreateValue(out_frame_tree));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageGetResourceContent(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_frame_id;
  if (!params || !params->GetString("frameId", &in_frame_id)) {
    client_.SendError(command_id, Response::InvalidParams("frameId"));
    return true;
  }
  std::string in_url;
  if (!params || !params->GetString("url", &in_url)) {
    client_.SendError(command_id, Response::InvalidParams("url"));
    return true;
  }
  Response response = page_handler_->GetResourceContent(
      command_id,
      in_frame_id,
      in_url);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnPageSearchInResource(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_frame_id;
  if (!params || !params->GetString("frameId", &in_frame_id)) {
    client_.SendError(command_id, Response::InvalidParams("frameId"));
    return true;
  }
  std::string in_url;
  if (!params || !params->GetString("url", &in_url)) {
    client_.SendError(command_id, Response::InvalidParams("url"));
    return true;
  }
  std::string in_query;
  if (!params || !params->GetString("query", &in_query)) {
    client_.SendError(command_id, Response::InvalidParams("query"));
    return true;
  }
  bool in_case_sensitive = false;
  bool case_sensitive_found = params && params->GetBoolean(
      "caseSensitive",
      &in_case_sensitive);
  bool in_is_regex = false;
  bool is_regex_found = params && params->GetBoolean(
      "isRegex",
      &in_is_regex);
  Response response = page_handler_->SearchInResource(
      command_id,
      in_frame_id,
      in_url,
      in_query,
      case_sensitive_found ? &in_case_sensitive : nullptr,
      is_regex_found ? &in_is_regex : nullptr);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnPageSetDocumentContent(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_frame_id;
  if (!params || !params->GetString("frameId", &in_frame_id)) {
    client_.SendError(command_id, Response::InvalidParams("frameId"));
    return true;
  }
  std::string in_html;
  if (!params || !params->GetString("html", &in_html)) {
    client_.SendError(command_id, Response::InvalidParams("html"));
    return true;
  }
  Response response = page_handler_->SetDocumentContent(
      in_frame_id,
      in_html);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageCaptureScreenshot(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = page_handler_->CaptureScreenshot(
      command_id);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnPageStartScreencast(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_format;
  bool format_found = params && params->GetString(
      "format",
      &in_format);
  int in_quality = 0;
  bool quality_found = params && params->GetInteger(
      "quality",
      &in_quality);
  int in_max_width = 0;
  bool max_width_found = params && params->GetInteger(
      "maxWidth",
      &in_max_width);
  int in_max_height = 0;
  bool max_height_found = params && params->GetInteger(
      "maxHeight",
      &in_max_height);
  int in_every_nth_frame = 0;
  bool every_nth_frame_found = params && params->GetInteger(
      "everyNthFrame",
      &in_every_nth_frame);
  Response response = page_handler_->StartScreencast(
      format_found ? &in_format : nullptr,
      quality_found ? &in_quality : nullptr,
      max_width_found ? &in_max_width : nullptr,
      max_height_found ? &in_max_height : nullptr,
      every_nth_frame_found ? &in_every_nth_frame : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageStopScreencast(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = page_handler_->StopScreencast();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageScreencastFrameAck(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_session_id = 0;
  if (!params || !params->GetInteger("sessionId", &in_session_id)) {
    client_.SendError(command_id, Response::InvalidParams("sessionId"));
    return true;
  }
  Response response = page_handler_->ScreencastFrameAck(
      in_session_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageHandleJavaScriptDialog(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_accept = false;
  if (!params || !params->GetBoolean("accept", &in_accept)) {
    client_.SendError(command_id, Response::InvalidParams("accept"));
    return true;
  }
  std::string in_prompt_text;
  bool prompt_text_found = params && params->GetString(
      "promptText",
      &in_prompt_text);
  Response response = page_handler_->HandleJavaScriptDialog(
      in_accept,
      prompt_text_found ? &in_prompt_text : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageSetColorPickerEnabled(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_enabled = false;
  if (!params || !params->GetBoolean("enabled", &in_enabled)) {
    client_.SendError(command_id, Response::InvalidParams("enabled"));
    return true;
  }
  Response response = page_handler_->SetColorPickerEnabled(
      in_enabled);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageConfigureOverlay(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_suspended = false;
  bool suspended_found = params && params->GetBoolean(
      "suspended",
      &in_suspended);
  std::string in_message;
  bool message_found = params && params->GetString(
      "message",
      &in_message);
  Response response = page_handler_->ConfigureOverlay(
      suspended_found ? &in_suspended : nullptr,
      message_found ? &in_message : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageGetAppManifest(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string out_url;
  std::vector<scoped_refptr<devtools::page::AppManifestError>> out_errors;
  std::string out_data;
  Response response = page_handler_->GetAppManifest(
      &out_url,
      &out_errors,
      &out_data);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("url", devtools::CreateValue(out_url));
  result->Set("errors", devtools::CreateValue(out_errors));
  result->Set("data", devtools::CreateValue(out_data));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageRequestAppBanner(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = page_handler_->RequestAppBanner();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageSetControlNavigations(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_enabled = false;
  if (!params || !params->GetBoolean("enabled", &in_enabled)) {
    client_.SendError(command_id, Response::InvalidParams("enabled"));
    return true;
  }
  Response response = page_handler_->SetControlNavigations(
      in_enabled);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageProcessNavigation(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_response;
  if (!params || !params->GetString("response", &in_response)) {
    client_.SendError(command_id, Response::InvalidParams("response"));
    return true;
  }
  int in_navigation_id = 0;
  if (!params || !params->GetInteger("navigationId", &in_navigation_id)) {
    client_.SendError(command_id, Response::InvalidParams("navigationId"));
    return true;
  }
  Response response = page_handler_->ProcessNavigation(
      in_response,
      in_navigation_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnPageGetLayoutMetrics(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  scoped_refptr<devtools::page::LayoutViewport> out_layout_viewport = nullptr;
  scoped_refptr<devtools::page::VisualViewport> out_visual_viewport = nullptr;
  Response response = page_handler_->GetLayoutMetrics(
      &out_layout_viewport,
      &out_visual_viewport);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("layoutViewport", devtools::CreateValue(out_layout_viewport));
  result->Set("visualViewport", devtools::CreateValue(out_visual_viewport));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetDeviceMetricsOverride(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_width = 0;
  if (!params || !params->GetInteger("width", &in_width)) {
    client_.SendError(command_id, Response::InvalidParams("width"));
    return true;
  }
  int in_height = 0;
  if (!params || !params->GetInteger("height", &in_height)) {
    client_.SendError(command_id, Response::InvalidParams("height"));
    return true;
  }
  double in_device_scale_factor = 0.0;
  if (!params || !params->GetDouble("deviceScaleFactor", &in_device_scale_factor)) {
    client_.SendError(command_id, Response::InvalidParams("deviceScaleFactor"));
    return true;
  }
  bool in_mobile = false;
  if (!params || !params->GetBoolean("mobile", &in_mobile)) {
    client_.SendError(command_id, Response::InvalidParams("mobile"));
    return true;
  }
  bool in_fit_window = false;
  if (!params || !params->GetBoolean("fitWindow", &in_fit_window)) {
    client_.SendError(command_id, Response::InvalidParams("fitWindow"));
    return true;
  }
  double in_scale = 0.0;
  bool scale_found = params && params->GetDouble(
      "scale",
      &in_scale);
  double in_offset_x = 0.0;
  bool offset_x_found = params && params->GetDouble(
      "offsetX",
      &in_offset_x);
  double in_offset_y = 0.0;
  bool offset_y_found = params && params->GetDouble(
      "offsetY",
      &in_offset_y);
  int in_screen_width = 0;
  bool screen_width_found = params && params->GetInteger(
      "screenWidth",
      &in_screen_width);
  int in_screen_height = 0;
  bool screen_height_found = params && params->GetInteger(
      "screenHeight",
      &in_screen_height);
  int in_position_x = 0;
  bool position_x_found = params && params->GetInteger(
      "positionX",
      &in_position_x);
  int in_position_y = 0;
  bool position_y_found = params && params->GetInteger(
      "positionY",
      &in_position_y);
  base::DictionaryValue* in_screen_orientation = nullptr;
  bool screen_orientation_found = params && params->GetDictionary(
      "screenOrientation",
      &in_screen_orientation);
  Response response = emulation_handler_->SetDeviceMetricsOverride(
      in_width,
      in_height,
      in_device_scale_factor,
      in_mobile,
      in_fit_window,
      scale_found ? &in_scale : nullptr,
      offset_x_found ? &in_offset_x : nullptr,
      offset_y_found ? &in_offset_y : nullptr,
      screen_width_found ? &in_screen_width : nullptr,
      screen_height_found ? &in_screen_height : nullptr,
      position_x_found ? &in_position_x : nullptr,
      position_y_found ? &in_position_y : nullptr,
      screen_orientation_found ? base::WrapUnique<base::DictionaryValue>(in_screen_orientation->DeepCopy()) : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationClearDeviceMetricsOverride(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = emulation_handler_->ClearDeviceMetricsOverride();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationForceViewport(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  double in_x = 0.0;
  if (!params || !params->GetDouble("x", &in_x)) {
    client_.SendError(command_id, Response::InvalidParams("x"));
    return true;
  }
  double in_y = 0.0;
  if (!params || !params->GetDouble("y", &in_y)) {
    client_.SendError(command_id, Response::InvalidParams("y"));
    return true;
  }
  double in_scale = 0.0;
  if (!params || !params->GetDouble("scale", &in_scale)) {
    client_.SendError(command_id, Response::InvalidParams("scale"));
    return true;
  }
  Response response = emulation_handler_->ForceViewport(
      in_x,
      in_y,
      in_scale);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationResetViewport(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = emulation_handler_->ResetViewport();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationResetPageScaleFactor(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = emulation_handler_->ResetPageScaleFactor();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetPageScaleFactor(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  double in_page_scale_factor = 0.0;
  if (!params || !params->GetDouble("pageScaleFactor", &in_page_scale_factor)) {
    client_.SendError(command_id, Response::InvalidParams("pageScaleFactor"));
    return true;
  }
  Response response = emulation_handler_->SetPageScaleFactor(
      in_page_scale_factor);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetVisibleSize(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_width = 0;
  if (!params || !params->GetInteger("width", &in_width)) {
    client_.SendError(command_id, Response::InvalidParams("width"));
    return true;
  }
  int in_height = 0;
  if (!params || !params->GetInteger("height", &in_height)) {
    client_.SendError(command_id, Response::InvalidParams("height"));
    return true;
  }
  Response response = emulation_handler_->SetVisibleSize(
      in_width,
      in_height);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetScriptExecutionDisabled(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_value = false;
  if (!params || !params->GetBoolean("value", &in_value)) {
    client_.SendError(command_id, Response::InvalidParams("value"));
    return true;
  }
  Response response = emulation_handler_->SetScriptExecutionDisabled(
      in_value);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetGeolocationOverride(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  double in_latitude = 0.0;
  bool latitude_found = params && params->GetDouble(
      "latitude",
      &in_latitude);
  double in_longitude = 0.0;
  bool longitude_found = params && params->GetDouble(
      "longitude",
      &in_longitude);
  double in_accuracy = 0.0;
  bool accuracy_found = params && params->GetDouble(
      "accuracy",
      &in_accuracy);
  Response response = emulation_handler_->SetGeolocationOverride(
      latitude_found ? &in_latitude : nullptr,
      longitude_found ? &in_longitude : nullptr,
      accuracy_found ? &in_accuracy : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationClearGeolocationOverride(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = emulation_handler_->ClearGeolocationOverride();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetTouchEmulationEnabled(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_enabled = false;
  if (!params || !params->GetBoolean("enabled", &in_enabled)) {
    client_.SendError(command_id, Response::InvalidParams("enabled"));
    return true;
  }
  std::string in_configuration;
  bool configuration_found = params && params->GetString(
      "configuration",
      &in_configuration);
  Response response = emulation_handler_->SetTouchEmulationEnabled(
      in_enabled,
      configuration_found ? &in_configuration : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetEmulatedMedia(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_media;
  if (!params || !params->GetString("media", &in_media)) {
    client_.SendError(command_id, Response::InvalidParams("media"));
    return true;
  }
  Response response = emulation_handler_->SetEmulatedMedia(
      in_media);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetCPUThrottlingRate(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  double in_rate = 0.0;
  if (!params || !params->GetDouble("rate", &in_rate)) {
    client_.SendError(command_id, Response::InvalidParams("rate"));
    return true;
  }
  Response response = emulation_handler_->SetCPUThrottlingRate(
      in_rate);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationCanEmulate(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool out_result = false;
  Response response = emulation_handler_->CanEmulate(
      &out_result);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("result", devtools::CreateValue(out_result));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnEmulationSetVirtualTimePolicy(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_policy;
  if (!params || !params->GetString("policy", &in_policy)) {
    client_.SendError(command_id, Response::InvalidParams("policy"));
    return true;
  }
  int in_budget = 0;
  bool budget_found = params && params->GetInteger(
      "budget",
      &in_budget);
  Response response = emulation_handler_->SetVirtualTimePolicy(
      in_policy,
      budget_found ? &in_budget : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnSecurityEnable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = security_handler_->Enable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnSecurityDisable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = security_handler_->Disable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnSecurityShowCertificateViewer(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = security_handler_->ShowCertificateViewer();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnNetworkEnable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_max_total_buffer_size = 0;
  bool max_total_buffer_size_found = params && params->GetInteger(
      "maxTotalBufferSize",
      &in_max_total_buffer_size);
  int in_max_resource_buffer_size = 0;
  bool max_resource_buffer_size_found = params && params->GetInteger(
      "maxResourceBufferSize",
      &in_max_resource_buffer_size);
  Response response = network_handler_->Enable(
      max_total_buffer_size_found ? &in_max_total_buffer_size : nullptr,
      max_resource_buffer_size_found ? &in_max_resource_buffer_size : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnNetworkDisable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = network_handler_->Disable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnNetworkClearBrowserCache(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = network_handler_->ClearBrowserCache();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnNetworkClearBrowserCookies(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = network_handler_->ClearBrowserCookies();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnNetworkGetCookies(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = network_handler_->GetCookies(
      command_id);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnNetworkDeleteCookie(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_cookie_name;
  if (!params || !params->GetString("cookieName", &in_cookie_name)) {
    client_.SendError(command_id, Response::InvalidParams("cookieName"));
    return true;
  }
  std::string in_url;
  if (!params || !params->GetString("url", &in_url)) {
    client_.SendError(command_id, Response::InvalidParams("url"));
    return true;
  }
  Response response = network_handler_->DeleteCookie(
      command_id,
      in_cookie_name,
      in_url);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnNetworkSetCookie(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_url;
  if (!params || !params->GetString("url", &in_url)) {
    client_.SendError(command_id, Response::InvalidParams("url"));
    return true;
  }
  std::string in_name;
  if (!params || !params->GetString("name", &in_name)) {
    client_.SendError(command_id, Response::InvalidParams("name"));
    return true;
  }
  std::string in_value;
  if (!params || !params->GetString("value", &in_value)) {
    client_.SendError(command_id, Response::InvalidParams("value"));
    return true;
  }
  std::string in_domain;
  bool domain_found = params && params->GetString(
      "domain",
      &in_domain);
  std::string in_path;
  bool path_found = params && params->GetString(
      "path",
      &in_path);
  bool in_secure = false;
  bool secure_found = params && params->GetBoolean(
      "secure",
      &in_secure);
  bool in_http_only = false;
  bool http_only_found = params && params->GetBoolean(
      "httpOnly",
      &in_http_only);
  std::string in_same_site;
  bool same_site_found = params && params->GetString(
      "sameSite",
      &in_same_site);
  double in_expiration_date = 0.0;
  bool expiration_date_found = params && params->GetDouble(
      "expirationDate",
      &in_expiration_date);
  Response response = network_handler_->SetCookie(
      command_id,
      in_url,
      in_name,
      in_value,
      domain_found ? &in_domain : nullptr,
      path_found ? &in_path : nullptr,
      secure_found ? &in_secure : nullptr,
      http_only_found ? &in_http_only : nullptr,
      same_site_found ? &in_same_site : nullptr,
      expiration_date_found ? &in_expiration_date : nullptr);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnNetworkCanEmulateNetworkConditions(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool out_result = false;
  Response response = network_handler_->CanEmulateNetworkConditions(
      &out_result);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("result", devtools::CreateValue(out_result));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnNetworkEmulateNetworkConditions(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_offline = false;
  if (!params || !params->GetBoolean("offline", &in_offline)) {
    client_.SendError(command_id, Response::InvalidParams("offline"));
    return true;
  }
  double in_latency = 0.0;
  if (!params || !params->GetDouble("latency", &in_latency)) {
    client_.SendError(command_id, Response::InvalidParams("latency"));
    return true;
  }
  double in_download_throughput = 0.0;
  if (!params || !params->GetDouble("downloadThroughput", &in_download_throughput)) {
    client_.SendError(command_id, Response::InvalidParams("downloadThroughput"));
    return true;
  }
  double in_upload_throughput = 0.0;
  if (!params || !params->GetDouble("uploadThroughput", &in_upload_throughput)) {
    client_.SendError(command_id, Response::InvalidParams("uploadThroughput"));
    return true;
  }
  std::string in_connection_type;
  bool connection_type_found = params && params->GetString(
      "connectionType",
      &in_connection_type);
  Response response = network_handler_->EmulateNetworkConditions(
      in_offline,
      in_latency,
      in_download_throughput,
      in_upload_throughput,
      connection_type_found ? &in_connection_type : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnDOMSetFileInputFiles(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_node_id = 0;
  if (!params || !params->GetInteger("nodeId", &in_node_id)) {
    client_.SendError(command_id, Response::InvalidParams("nodeId"));
    return true;
  }
  base::ListValue* list_files = nullptr;
  if (!params || !params->GetList("files", &list_files)) {
    client_.SendError(command_id, Response::InvalidParams("files"));
    return true;
  }
  std::vector<std::string> in_files;
  for (base::ListValue::const_iterator it =
      list_files->begin(); it != list_files->end(); ++it) {
    std::string item;
    if (!(*it)->GetAsString(&item)) {
      client_.SendError(command_id, Response::InvalidParams("files"));
      return true;
    }
    in_files.push_back(item);
  }
  Response response = dom_handler_->SetFileInputFiles(
      in_node_id,
      in_files);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnIORead(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_handle;
  if (!params || !params->GetString("handle", &in_handle)) {
    client_.SendError(command_id, Response::InvalidParams("handle"));
    return true;
  }
  int in_offset = 0;
  bool offset_found = params && params->GetInteger(
      "offset",
      &in_offset);
  int in_size = 0;
  bool size_found = params && params->GetInteger(
      "size",
      &in_size);
  Response response = io_handler_->Read(
      command_id,
      in_handle,
      offset_found ? &in_offset : nullptr,
      size_found ? &in_size : nullptr);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnIOClose(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_handle;
  if (!params || !params->GetString("handle", &in_handle)) {
    client_.SendError(command_id, Response::InvalidParams("handle"));
    return true;
  }
  Response response = io_handler_->Close(
      in_handle);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetSetDiscoverTargets(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_discover = false;
  if (!params || !params->GetBoolean("discover", &in_discover)) {
    client_.SendError(command_id, Response::InvalidParams("discover"));
    return true;
  }
  Response response = target_handler_->SetDiscoverTargets(
      in_discover);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetSetAutoAttach(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_auto_attach = false;
  if (!params || !params->GetBoolean("autoAttach", &in_auto_attach)) {
    client_.SendError(command_id, Response::InvalidParams("autoAttach"));
    return true;
  }
  bool in_wait_for_debugger_on_start = false;
  if (!params || !params->GetBoolean("waitForDebuggerOnStart", &in_wait_for_debugger_on_start)) {
    client_.SendError(command_id, Response::InvalidParams("waitForDebuggerOnStart"));
    return true;
  }
  Response response = target_handler_->SetAutoAttach(
      in_auto_attach,
      in_wait_for_debugger_on_start);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetSetAttachToFrames(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_value = false;
  if (!params || !params->GetBoolean("value", &in_value)) {
    client_.SendError(command_id, Response::InvalidParams("value"));
    return true;
  }
  Response response = target_handler_->SetAttachToFrames(
      in_value);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetSetRemoteLocations(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  base::ListValue* list_locations = nullptr;
  if (!params || !params->GetList("locations", &list_locations)) {
    client_.SendError(command_id, Response::InvalidParams("locations"));
    return true;
  }
  std::vector<std::unique_ptr<base::DictionaryValue>> in_locations;
  for (base::ListValue::const_iterator it =
      list_locations->begin(); it != list_locations->end(); ++it) {
    base::DictionaryValue* item;
    if (!(*it)->GetAsDictionary(&item)) {
      client_.SendError(command_id, Response::InvalidParams("locations"));
      return true;
    }
    in_locations.push_back(base::WrapUnique<base::DictionaryValue>(item->DeepCopy()));
  }
  Response response = target_handler_->SetRemoteLocations(
      in_locations);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetSendMessageToTarget(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_target_id;
  if (!params || !params->GetString("targetId", &in_target_id)) {
    client_.SendError(command_id, Response::InvalidParams("targetId"));
    return true;
  }
  std::string in_message;
  if (!params || !params->GetString("message", &in_message)) {
    client_.SendError(command_id, Response::InvalidParams("message"));
    return true;
  }
  Response response = target_handler_->SendMessageToTarget(
      in_target_id,
      in_message);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetGetTargetInfo(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_target_id;
  if (!params || !params->GetString("targetId", &in_target_id)) {
    client_.SendError(command_id, Response::InvalidParams("targetId"));
    return true;
  }
  scoped_refptr<devtools::target::TargetInfo> out_target_info = nullptr;
  Response response = target_handler_->GetTargetInfo(
      in_target_id,
      &out_target_info);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("targetInfo", devtools::CreateValue(out_target_info));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetActivateTarget(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_target_id;
  if (!params || !params->GetString("targetId", &in_target_id)) {
    client_.SendError(command_id, Response::InvalidParams("targetId"));
    return true;
  }
  Response response = target_handler_->ActivateTarget(
      in_target_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetCloseTarget(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_target_id;
  if (!params || !params->GetString("targetId", &in_target_id)) {
    client_.SendError(command_id, Response::InvalidParams("targetId"));
    return true;
  }
  bool out_success = false;
  Response response = target_handler_->CloseTarget(
      in_target_id,
      &out_success);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("success", devtools::CreateValue(out_success));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetAttachToTarget(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_target_id;
  if (!params || !params->GetString("targetId", &in_target_id)) {
    client_.SendError(command_id, Response::InvalidParams("targetId"));
    return true;
  }
  bool out_success = false;
  Response response = target_handler_->AttachToTarget(
      in_target_id,
      &out_success);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("success", devtools::CreateValue(out_success));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetDetachFromTarget(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_target_id;
  if (!params || !params->GetString("targetId", &in_target_id)) {
    client_.SendError(command_id, Response::InvalidParams("targetId"));
    return true;
  }
  Response response = target_handler_->DetachFromTarget(
      in_target_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetCreateBrowserContext(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string out_browser_context_id;
  Response response = target_handler_->CreateBrowserContext(
      &out_browser_context_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("browserContextId", devtools::CreateValue(out_browser_context_id));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetDisposeBrowserContext(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_browser_context_id;
  if (!params || !params->GetString("browserContextId", &in_browser_context_id)) {
    client_.SendError(command_id, Response::InvalidParams("browserContextId"));
    return true;
  }
  bool out_success = false;
  Response response = target_handler_->DisposeBrowserContext(
      in_browser_context_id,
      &out_success);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("success", devtools::CreateValue(out_success));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetCreateTarget(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_url;
  if (!params || !params->GetString("url", &in_url)) {
    client_.SendError(command_id, Response::InvalidParams("url"));
    return true;
  }
  int in_width = 0;
  bool width_found = params && params->GetInteger(
      "width",
      &in_width);
  int in_height = 0;
  bool height_found = params && params->GetInteger(
      "height",
      &in_height);
  std::string in_browser_context_id;
  bool browser_context_id_found = params && params->GetString(
      "browserContextId",
      &in_browser_context_id);
  std::string out_target_id;
  Response response = target_handler_->CreateTarget(
      in_url,
      width_found ? &in_width : nullptr,
      height_found ? &in_height : nullptr,
      browser_context_id_found ? &in_browser_context_id : nullptr,
      &out_target_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("targetId", devtools::CreateValue(out_target_id));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnTargetGetTargets(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::vector<scoped_refptr<devtools::target::TargetInfo>> out_target_infos;
  Response response = target_handler_->GetTargets(
      &out_target_infos);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("targetInfos", devtools::CreateValue(out_target_infos));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerEnable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = service_worker_handler_->Enable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerDisable(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = service_worker_handler_->Disable();
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerUnregister(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_scope_url;
  if (!params || !params->GetString("scopeURL", &in_scope_url)) {
    client_.SendError(command_id, Response::InvalidParams("scopeURL"));
    return true;
  }
  Response response = service_worker_handler_->Unregister(
      in_scope_url);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerUpdateRegistration(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_scope_url;
  if (!params || !params->GetString("scopeURL", &in_scope_url)) {
    client_.SendError(command_id, Response::InvalidParams("scopeURL"));
    return true;
  }
  Response response = service_worker_handler_->UpdateRegistration(
      in_scope_url);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerStartWorker(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_scope_url;
  if (!params || !params->GetString("scopeURL", &in_scope_url)) {
    client_.SendError(command_id, Response::InvalidParams("scopeURL"));
    return true;
  }
  Response response = service_worker_handler_->StartWorker(
      in_scope_url);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerSkipWaiting(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_scope_url;
  if (!params || !params->GetString("scopeURL", &in_scope_url)) {
    client_.SendError(command_id, Response::InvalidParams("scopeURL"));
    return true;
  }
  Response response = service_worker_handler_->SkipWaiting(
      in_scope_url);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerStopWorker(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_version_id;
  if (!params || !params->GetString("versionId", &in_version_id)) {
    client_.SendError(command_id, Response::InvalidParams("versionId"));
    return true;
  }
  Response response = service_worker_handler_->StopWorker(
      in_version_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerInspectWorker(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_version_id;
  if (!params || !params->GetString("versionId", &in_version_id)) {
    client_.SendError(command_id, Response::InvalidParams("versionId"));
    return true;
  }
  Response response = service_worker_handler_->InspectWorker(
      in_version_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerSetForceUpdateOnPageLoad(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  bool in_force_update_on_page_load = false;
  if (!params || !params->GetBoolean("forceUpdateOnPageLoad", &in_force_update_on_page_load)) {
    client_.SendError(command_id, Response::InvalidParams("forceUpdateOnPageLoad"));
    return true;
  }
  Response response = service_worker_handler_->SetForceUpdateOnPageLoad(
      in_force_update_on_page_load);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerDeliverPushMessage(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_origin;
  if (!params || !params->GetString("origin", &in_origin)) {
    client_.SendError(command_id, Response::InvalidParams("origin"));
    return true;
  }
  std::string in_registration_id;
  if (!params || !params->GetString("registrationId", &in_registration_id)) {
    client_.SendError(command_id, Response::InvalidParams("registrationId"));
    return true;
  }
  std::string in_data;
  if (!params || !params->GetString("data", &in_data)) {
    client_.SendError(command_id, Response::InvalidParams("data"));
    return true;
  }
  Response response = service_worker_handler_->DeliverPushMessage(
      in_origin,
      in_registration_id,
      in_data);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnServiceWorkerDispatchSyncEvent(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_origin;
  if (!params || !params->GetString("origin", &in_origin)) {
    client_.SendError(command_id, Response::InvalidParams("origin"));
    return true;
  }
  std::string in_registration_id;
  if (!params || !params->GetString("registrationId", &in_registration_id)) {
    client_.SendError(command_id, Response::InvalidParams("registrationId"));
    return true;
  }
  std::string in_tag;
  if (!params || !params->GetString("tag", &in_tag)) {
    client_.SendError(command_id, Response::InvalidParams("tag"));
    return true;
  }
  bool in_last_chance = false;
  if (!params || !params->GetBoolean("lastChance", &in_last_chance)) {
    client_.SendError(command_id, Response::InvalidParams("lastChance"));
    return true;
  }
  Response response = service_worker_handler_->DispatchSyncEvent(
      in_origin,
      in_registration_id,
      in_tag,
      in_last_chance);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnInputDispatchKeyEvent(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_type;
  if (!params || !params->GetString("type", &in_type)) {
    client_.SendError(command_id, Response::InvalidParams("type"));
    return true;
  }
  int in_modifiers = 0;
  bool modifiers_found = params && params->GetInteger(
      "modifiers",
      &in_modifiers);
  double in_timestamp = 0.0;
  bool timestamp_found = params && params->GetDouble(
      "timestamp",
      &in_timestamp);
  std::string in_text;
  bool text_found = params && params->GetString(
      "text",
      &in_text);
  std::string in_unmodified_text;
  bool unmodified_text_found = params && params->GetString(
      "unmodifiedText",
      &in_unmodified_text);
  std::string in_key_identifier;
  bool key_identifier_found = params && params->GetString(
      "keyIdentifier",
      &in_key_identifier);
  std::string in_code;
  bool code_found = params && params->GetString(
      "code",
      &in_code);
  std::string in_key;
  bool key_found = params && params->GetString(
      "key",
      &in_key);
  int in_windows_virtual_key_code = 0;
  bool windows_virtual_key_code_found = params && params->GetInteger(
      "windowsVirtualKeyCode",
      &in_windows_virtual_key_code);
  int in_native_virtual_key_code = 0;
  bool native_virtual_key_code_found = params && params->GetInteger(
      "nativeVirtualKeyCode",
      &in_native_virtual_key_code);
  bool in_auto_repeat = false;
  bool auto_repeat_found = params && params->GetBoolean(
      "autoRepeat",
      &in_auto_repeat);
  bool in_is_keypad = false;
  bool is_keypad_found = params && params->GetBoolean(
      "isKeypad",
      &in_is_keypad);
  bool in_is_system_key = false;
  bool is_system_key_found = params && params->GetBoolean(
      "isSystemKey",
      &in_is_system_key);
  Response response = input_handler_->DispatchKeyEvent(
      in_type,
      modifiers_found ? &in_modifiers : nullptr,
      timestamp_found ? &in_timestamp : nullptr,
      text_found ? &in_text : nullptr,
      unmodified_text_found ? &in_unmodified_text : nullptr,
      key_identifier_found ? &in_key_identifier : nullptr,
      code_found ? &in_code : nullptr,
      key_found ? &in_key : nullptr,
      windows_virtual_key_code_found ? &in_windows_virtual_key_code : nullptr,
      native_virtual_key_code_found ? &in_native_virtual_key_code : nullptr,
      auto_repeat_found ? &in_auto_repeat : nullptr,
      is_keypad_found ? &in_is_keypad : nullptr,
      is_system_key_found ? &in_is_system_key : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnInputDispatchMouseEvent(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_type;
  if (!params || !params->GetString("type", &in_type)) {
    client_.SendError(command_id, Response::InvalidParams("type"));
    return true;
  }
  int in_x = 0;
  if (!params || !params->GetInteger("x", &in_x)) {
    client_.SendError(command_id, Response::InvalidParams("x"));
    return true;
  }
  int in_y = 0;
  if (!params || !params->GetInteger("y", &in_y)) {
    client_.SendError(command_id, Response::InvalidParams("y"));
    return true;
  }
  int in_modifiers = 0;
  bool modifiers_found = params && params->GetInteger(
      "modifiers",
      &in_modifiers);
  double in_timestamp = 0.0;
  bool timestamp_found = params && params->GetDouble(
      "timestamp",
      &in_timestamp);
  std::string in_button;
  bool button_found = params && params->GetString(
      "button",
      &in_button);
  int in_click_count = 0;
  bool click_count_found = params && params->GetInteger(
      "clickCount",
      &in_click_count);
  Response response = input_handler_->DispatchMouseEvent(
      in_type,
      in_x,
      in_y,
      modifiers_found ? &in_modifiers : nullptr,
      timestamp_found ? &in_timestamp : nullptr,
      button_found ? &in_button : nullptr,
      click_count_found ? &in_click_count : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnInputDispatchTouchEvent(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_type;
  if (!params || !params->GetString("type", &in_type)) {
    client_.SendError(command_id, Response::InvalidParams("type"));
    return true;
  }
  base::ListValue* list_touch_points = nullptr;
  if (!params || !params->GetList("touchPoints", &list_touch_points)) {
    client_.SendError(command_id, Response::InvalidParams("touchPoints"));
    return true;
  }
  std::vector<std::unique_ptr<base::DictionaryValue>> in_touch_points;
  for (base::ListValue::const_iterator it =
      list_touch_points->begin(); it != list_touch_points->end(); ++it) {
    base::DictionaryValue* item;
    if (!(*it)->GetAsDictionary(&item)) {
      client_.SendError(command_id, Response::InvalidParams("touchPoints"));
      return true;
    }
    in_touch_points.push_back(base::WrapUnique<base::DictionaryValue>(item->DeepCopy()));
  }
  int in_modifiers = 0;
  bool modifiers_found = params && params->GetInteger(
      "modifiers",
      &in_modifiers);
  double in_timestamp = 0.0;
  bool timestamp_found = params && params->GetDouble(
      "timestamp",
      &in_timestamp);
  Response response = input_handler_->DispatchTouchEvent(
      in_type,
      in_touch_points,
      modifiers_found ? &in_modifiers : nullptr,
      timestamp_found ? &in_timestamp : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnInputEmulateTouchFromMouseEvent(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_type;
  if (!params || !params->GetString("type", &in_type)) {
    client_.SendError(command_id, Response::InvalidParams("type"));
    return true;
  }
  int in_x = 0;
  if (!params || !params->GetInteger("x", &in_x)) {
    client_.SendError(command_id, Response::InvalidParams("x"));
    return true;
  }
  int in_y = 0;
  if (!params || !params->GetInteger("y", &in_y)) {
    client_.SendError(command_id, Response::InvalidParams("y"));
    return true;
  }
  double in_timestamp = 0.0;
  if (!params || !params->GetDouble("timestamp", &in_timestamp)) {
    client_.SendError(command_id, Response::InvalidParams("timestamp"));
    return true;
  }
  std::string in_button;
  if (!params || !params->GetString("button", &in_button)) {
    client_.SendError(command_id, Response::InvalidParams("button"));
    return true;
  }
  double in_delta_x = 0.0;
  bool delta_x_found = params && params->GetDouble(
      "deltaX",
      &in_delta_x);
  double in_delta_y = 0.0;
  bool delta_y_found = params && params->GetDouble(
      "deltaY",
      &in_delta_y);
  int in_modifiers = 0;
  bool modifiers_found = params && params->GetInteger(
      "modifiers",
      &in_modifiers);
  int in_click_count = 0;
  bool click_count_found = params && params->GetInteger(
      "clickCount",
      &in_click_count);
  Response response = input_handler_->EmulateTouchFromMouseEvent(
      in_type,
      in_x,
      in_y,
      in_timestamp,
      in_button,
      delta_x_found ? &in_delta_x : nullptr,
      delta_y_found ? &in_delta_y : nullptr,
      modifiers_found ? &in_modifiers : nullptr,
      click_count_found ? &in_click_count : nullptr);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnInputSynthesizePinchGesture(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_x = 0;
  if (!params || !params->GetInteger("x", &in_x)) {
    client_.SendError(command_id, Response::InvalidParams("x"));
    return true;
  }
  int in_y = 0;
  if (!params || !params->GetInteger("y", &in_y)) {
    client_.SendError(command_id, Response::InvalidParams("y"));
    return true;
  }
  double in_scale_factor = 0.0;
  if (!params || !params->GetDouble("scaleFactor", &in_scale_factor)) {
    client_.SendError(command_id, Response::InvalidParams("scaleFactor"));
    return true;
  }
  int in_relative_speed = 0;
  bool relative_speed_found = params && params->GetInteger(
      "relativeSpeed",
      &in_relative_speed);
  std::string in_gesture_source_type;
  bool gesture_source_type_found = params && params->GetString(
      "gestureSourceType",
      &in_gesture_source_type);
  Response response = input_handler_->SynthesizePinchGesture(
      command_id,
      in_x,
      in_y,
      in_scale_factor,
      relative_speed_found ? &in_relative_speed : nullptr,
      gesture_source_type_found ? &in_gesture_source_type : nullptr);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnInputSynthesizeScrollGesture(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_x = 0;
  if (!params || !params->GetInteger("x", &in_x)) {
    client_.SendError(command_id, Response::InvalidParams("x"));
    return true;
  }
  int in_y = 0;
  if (!params || !params->GetInteger("y", &in_y)) {
    client_.SendError(command_id, Response::InvalidParams("y"));
    return true;
  }
  int in_x_distance = 0;
  bool x_distance_found = params && params->GetInteger(
      "xDistance",
      &in_x_distance);
  int in_y_distance = 0;
  bool y_distance_found = params && params->GetInteger(
      "yDistance",
      &in_y_distance);
  int in_x_overscroll = 0;
  bool x_overscroll_found = params && params->GetInteger(
      "xOverscroll",
      &in_x_overscroll);
  int in_y_overscroll = 0;
  bool y_overscroll_found = params && params->GetInteger(
      "yOverscroll",
      &in_y_overscroll);
  bool in_prevent_fling = false;
  bool prevent_fling_found = params && params->GetBoolean(
      "preventFling",
      &in_prevent_fling);
  int in_speed = 0;
  bool speed_found = params && params->GetInteger(
      "speed",
      &in_speed);
  std::string in_gesture_source_type;
  bool gesture_source_type_found = params && params->GetString(
      "gestureSourceType",
      &in_gesture_source_type);
  int in_repeat_count = 0;
  bool repeat_count_found = params && params->GetInteger(
      "repeatCount",
      &in_repeat_count);
  int in_repeat_delay_ms = 0;
  bool repeat_delay_ms_found = params && params->GetInteger(
      "repeatDelayMs",
      &in_repeat_delay_ms);
  std::string in_interaction_marker_name;
  bool interaction_marker_name_found = params && params->GetString(
      "interactionMarkerName",
      &in_interaction_marker_name);
  Response response = input_handler_->SynthesizeScrollGesture(
      command_id,
      in_x,
      in_y,
      x_distance_found ? &in_x_distance : nullptr,
      y_distance_found ? &in_y_distance : nullptr,
      x_overscroll_found ? &in_x_overscroll : nullptr,
      y_overscroll_found ? &in_y_overscroll : nullptr,
      prevent_fling_found ? &in_prevent_fling : nullptr,
      speed_found ? &in_speed : nullptr,
      gesture_source_type_found ? &in_gesture_source_type : nullptr,
      repeat_count_found ? &in_repeat_count : nullptr,
      repeat_delay_ms_found ? &in_repeat_delay_ms : nullptr,
      interaction_marker_name_found ? &in_interaction_marker_name : nullptr);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnInputSynthesizeTapGesture(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_x = 0;
  if (!params || !params->GetInteger("x", &in_x)) {
    client_.SendError(command_id, Response::InvalidParams("x"));
    return true;
  }
  int in_y = 0;
  if (!params || !params->GetInteger("y", &in_y)) {
    client_.SendError(command_id, Response::InvalidParams("y"));
    return true;
  }
  int in_duration = 0;
  bool duration_found = params && params->GetInteger(
      "duration",
      &in_duration);
  int in_tap_count = 0;
  bool tap_count_found = params && params->GetInteger(
      "tapCount",
      &in_tap_count);
  std::string in_gesture_source_type;
  bool gesture_source_type_found = params && params->GetString(
      "gestureSourceType",
      &in_gesture_source_type);
  Response response = input_handler_->SynthesizeTapGesture(
      command_id,
      in_x,
      in_y,
      duration_found ? &in_duration : nullptr,
      tap_count_found ? &in_tap_count : nullptr,
      gesture_source_type_found ? &in_gesture_source_type : nullptr);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnTracingStart(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_categories;
  bool categories_found = params && params->GetString(
      "categories",
      &in_categories);
  std::string in_options;
  bool options_found = params && params->GetString(
      "options",
      &in_options);
  double in_buffer_usage_reporting_interval = 0.0;
  bool buffer_usage_reporting_interval_found = params && params->GetDouble(
      "bufferUsageReportingInterval",
      &in_buffer_usage_reporting_interval);
  std::string in_transfer_mode;
  bool transfer_mode_found = params && params->GetString(
      "transferMode",
      &in_transfer_mode);
  base::DictionaryValue* in_trace_config = nullptr;
  bool trace_config_found = params && params->GetDictionary(
      "traceConfig",
      &in_trace_config);
  Response response = tracing_handler_->Start(
      command_id,
      categories_found ? &in_categories : nullptr,
      options_found ? &in_options : nullptr,
      buffer_usage_reporting_interval_found ? &in_buffer_usage_reporting_interval : nullptr,
      transfer_mode_found ? &in_transfer_mode : nullptr,
      trace_config_found ? base::WrapUnique<base::DictionaryValue>(in_trace_config->DeepCopy()) : nullptr);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnTracingEnd(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = tracing_handler_->End(
      command_id);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnTracingGetCategories(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = tracing_handler_->GetCategories(
      command_id);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnTracingRequestMemoryDump(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = tracing_handler_->RequestMemoryDump(
      command_id);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnTracingRecordClockSyncMarker(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_sync_id;
  if (!params || !params->GetString("syncId", &in_sync_id)) {
    client_.SendError(command_id, Response::InvalidParams("syncId"));
    return true;
  }
  Response response = tracing_handler_->RecordClockSyncMarker(
      in_sync_id);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnStorageClearDataForOrigin(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::string in_origin;
  if (!params || !params->GetString("origin", &in_origin)) {
    client_.SendError(command_id, Response::InvalidParams("origin"));
    return true;
  }
  std::string in_storage_types;
  if (!params || !params->GetString("storageTypes", &in_storage_types)) {
    client_.SendError(command_id, Response::InvalidParams("storageTypes"));
    return true;
  }
  Response response = storage_handler_->ClearDataForOrigin(
      in_origin,
      in_storage_types);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

bool DevToolsProtocolDispatcher::OnSystemInfoGetInfo(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  Response response = system_info_handler_->GetInfo(
      command_id);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnTetheringBind(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_port = 0;
  if (!params || !params->GetInteger("port", &in_port)) {
    client_.SendError(command_id, Response::InvalidParams("port"));
    return true;
  }
  Response response = tethering_handler_->Bind(
      command_id,
      in_port);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnTetheringUnbind(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  int in_port = 0;
  if (!params || !params->GetInteger("port", &in_port)) {
    client_.SendError(command_id, Response::InvalidParams("port"));
    return true;
  }
  Response response = tethering_handler_->Unbind(
      command_id,
      in_port);
  if (client_.SendError(command_id, response))
    return true;
  return !response.IsFallThrough();
}

bool DevToolsProtocolDispatcher::OnSchemaGetDomains(
    DevToolsCommandId command_id,
    std::unique_ptr<base::DictionaryValue> params) {
  std::vector<scoped_refptr<devtools::schema::Domain>> out_domains;
  Response response = schema_handler_->GetDomains(
      &out_domains);
  std::unique_ptr<base::DictionaryValue> protocol_response;
  if (client_.SendError(command_id, response))
    return true;
  if (response.IsFallThrough())
    return false;
  std::unique_ptr<base::DictionaryValue> result(new base::DictionaryValue());
  result->Set("domains", devtools::CreateValue(out_domains));
  client_.SendSuccess(command_id, std::move(result));
  return true;
}

void DevToolsProtocolDispatcher::SetInspectorHandler(
    devtools::inspector::InspectorHandler* inspector_handler) {
  DCHECK(!inspector_handler_);
  inspector_handler_ = inspector_handler;
  command_handlers_["Inspector.enable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInspectorEnable,
          base::Unretained(this));
  command_handlers_["Inspector.disable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInspectorDisable,
          base::Unretained(this));
  inspector_handler_->SetClient(base::WrapUnique(
      new devtools::inspector::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetMemoryHandler(
    devtools::memory::MemoryHandler* memory_handler) {
  DCHECK(!memory_handler_);
  memory_handler_ = memory_handler;
  command_handlers_["Memory.getDOMCounters"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnMemoryGetDOMCounters,
          base::Unretained(this));
  command_handlers_["Memory.setPressureNotificationsSuppressed"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnMemorySetPressureNotificationsSuppressed,
          base::Unretained(this));
  command_handlers_["Memory.simulatePressureNotification"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnMemorySimulatePressureNotification,
          base::Unretained(this));
}

void DevToolsProtocolDispatcher::SetPageHandler(
    devtools::page::PageHandler* page_handler) {
  DCHECK(!page_handler_);
  page_handler_ = page_handler;
  command_handlers_["Page.enable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageEnable,
          base::Unretained(this));
  command_handlers_["Page.disable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageDisable,
          base::Unretained(this));
  command_handlers_["Page.addScriptToEvaluateOnLoad"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageAddScriptToEvaluateOnLoad,
          base::Unretained(this));
  command_handlers_["Page.removeScriptToEvaluateOnLoad"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageRemoveScriptToEvaluateOnLoad,
          base::Unretained(this));
  command_handlers_["Page.setAutoAttachToCreatedPages"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageSetAutoAttachToCreatedPages,
          base::Unretained(this));
  command_handlers_["Page.reload"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageReload,
          base::Unretained(this));
  command_handlers_["Page.navigate"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageNavigate,
          base::Unretained(this));
  command_handlers_["Page.getNavigationHistory"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageGetNavigationHistory,
          base::Unretained(this));
  command_handlers_["Page.navigateToHistoryEntry"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageNavigateToHistoryEntry,
          base::Unretained(this));
  command_handlers_["Page.getResourceTree"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageGetResourceTree,
          base::Unretained(this));
  command_handlers_["Page.getResourceContent"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageGetResourceContent,
          base::Unretained(this));
  command_handlers_["Page.searchInResource"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageSearchInResource,
          base::Unretained(this));
  command_handlers_["Page.setDocumentContent"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageSetDocumentContent,
          base::Unretained(this));
  command_handlers_["Page.captureScreenshot"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageCaptureScreenshot,
          base::Unretained(this));
  command_handlers_["Page.startScreencast"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageStartScreencast,
          base::Unretained(this));
  command_handlers_["Page.stopScreencast"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageStopScreencast,
          base::Unretained(this));
  command_handlers_["Page.screencastFrameAck"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageScreencastFrameAck,
          base::Unretained(this));
  command_handlers_["Page.handleJavaScriptDialog"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageHandleJavaScriptDialog,
          base::Unretained(this));
  command_handlers_["Page.setColorPickerEnabled"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageSetColorPickerEnabled,
          base::Unretained(this));
  command_handlers_["Page.configureOverlay"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageConfigureOverlay,
          base::Unretained(this));
  command_handlers_["Page.getAppManifest"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageGetAppManifest,
          base::Unretained(this));
  command_handlers_["Page.requestAppBanner"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageRequestAppBanner,
          base::Unretained(this));
  command_handlers_["Page.setControlNavigations"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageSetControlNavigations,
          base::Unretained(this));
  command_handlers_["Page.processNavigation"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageProcessNavigation,
          base::Unretained(this));
  command_handlers_["Page.getLayoutMetrics"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnPageGetLayoutMetrics,
          base::Unretained(this));
  page_handler_->SetClient(base::WrapUnique(
      new devtools::page::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetEmulationHandler(
    devtools::emulation::EmulationHandler* emulation_handler) {
  DCHECK(!emulation_handler_);
  emulation_handler_ = emulation_handler;
  command_handlers_["Emulation.setDeviceMetricsOverride"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetDeviceMetricsOverride,
          base::Unretained(this));
  command_handlers_["Emulation.clearDeviceMetricsOverride"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationClearDeviceMetricsOverride,
          base::Unretained(this));
  command_handlers_["Emulation.forceViewport"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationForceViewport,
          base::Unretained(this));
  command_handlers_["Emulation.resetViewport"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationResetViewport,
          base::Unretained(this));
  command_handlers_["Emulation.resetPageScaleFactor"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationResetPageScaleFactor,
          base::Unretained(this));
  command_handlers_["Emulation.setPageScaleFactor"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetPageScaleFactor,
          base::Unretained(this));
  command_handlers_["Emulation.setVisibleSize"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetVisibleSize,
          base::Unretained(this));
  command_handlers_["Emulation.setScriptExecutionDisabled"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetScriptExecutionDisabled,
          base::Unretained(this));
  command_handlers_["Emulation.setGeolocationOverride"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetGeolocationOverride,
          base::Unretained(this));
  command_handlers_["Emulation.clearGeolocationOverride"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationClearGeolocationOverride,
          base::Unretained(this));
  command_handlers_["Emulation.setTouchEmulationEnabled"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetTouchEmulationEnabled,
          base::Unretained(this));
  command_handlers_["Emulation.setEmulatedMedia"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetEmulatedMedia,
          base::Unretained(this));
  command_handlers_["Emulation.setCPUThrottlingRate"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetCPUThrottlingRate,
          base::Unretained(this));
  command_handlers_["Emulation.canEmulate"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationCanEmulate,
          base::Unretained(this));
  command_handlers_["Emulation.setVirtualTimePolicy"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetVirtualTimePolicy,
          base::Unretained(this));
  emulation_handler_->SetClient(base::WrapUnique(
      new devtools::emulation::Client(notifier_)));
  command_handlers_["Page.setDeviceMetricsOverride"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetDeviceMetricsOverride,
          base::Unretained(this));
  command_handlers_["Page.clearDeviceMetricsOverride"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationClearDeviceMetricsOverride,
          base::Unretained(this));
  command_handlers_["Page.setGeolocationOverride"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetGeolocationOverride,
          base::Unretained(this));
  command_handlers_["Page.clearGeolocationOverride"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationClearGeolocationOverride,
          base::Unretained(this));
  command_handlers_["Page.setTouchEmulationEnabled"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnEmulationSetTouchEmulationEnabled,
          base::Unretained(this));
}

void DevToolsProtocolDispatcher::SetSecurityHandler(
    devtools::security::SecurityHandler* security_handler) {
  DCHECK(!security_handler_);
  security_handler_ = security_handler;
  command_handlers_["Security.enable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnSecurityEnable,
          base::Unretained(this));
  command_handlers_["Security.disable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnSecurityDisable,
          base::Unretained(this));
  command_handlers_["Security.showCertificateViewer"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnSecurityShowCertificateViewer,
          base::Unretained(this));
  security_handler_->SetClient(base::WrapUnique(
      new devtools::security::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetNetworkHandler(
    devtools::network::NetworkHandler* network_handler) {
  DCHECK(!network_handler_);
  network_handler_ = network_handler;
  command_handlers_["Network.enable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkEnable,
          base::Unretained(this));
  command_handlers_["Network.disable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkDisable,
          base::Unretained(this));
  command_handlers_["Network.clearBrowserCache"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkClearBrowserCache,
          base::Unretained(this));
  command_handlers_["Network.clearBrowserCookies"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkClearBrowserCookies,
          base::Unretained(this));
  command_handlers_["Network.getCookies"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkGetCookies,
          base::Unretained(this));
  command_handlers_["Network.deleteCookie"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkDeleteCookie,
          base::Unretained(this));
  command_handlers_["Network.setCookie"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkSetCookie,
          base::Unretained(this));
  command_handlers_["Network.canEmulateNetworkConditions"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkCanEmulateNetworkConditions,
          base::Unretained(this));
  command_handlers_["Network.emulateNetworkConditions"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkEmulateNetworkConditions,
          base::Unretained(this));
  network_handler_->SetClient(base::WrapUnique(
      new devtools::network::Client(notifier_)));
  command_handlers_["Page.getCookies"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkGetCookies,
          base::Unretained(this));
  command_handlers_["Page.deleteCookie"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnNetworkDeleteCookie,
          base::Unretained(this));
}

void DevToolsProtocolDispatcher::SetDOMHandler(
    devtools::dom::DOMHandler* dom_handler) {
  DCHECK(!dom_handler_);
  dom_handler_ = dom_handler;
  command_handlers_["DOM.setFileInputFiles"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnDOMSetFileInputFiles,
          base::Unretained(this));
}

void DevToolsProtocolDispatcher::SetIOHandler(
    devtools::io::IOHandler* io_handler) {
  DCHECK(!io_handler_);
  io_handler_ = io_handler;
  command_handlers_["IO.read"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnIORead,
          base::Unretained(this));
  command_handlers_["IO.close"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnIOClose,
          base::Unretained(this));
  io_handler_->SetClient(base::WrapUnique(
      new devtools::io::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetTargetHandler(
    devtools::target::TargetHandler* target_handler) {
  DCHECK(!target_handler_);
  target_handler_ = target_handler;
  command_handlers_["Target.setDiscoverTargets"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetSetDiscoverTargets,
          base::Unretained(this));
  command_handlers_["Target.setAutoAttach"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetSetAutoAttach,
          base::Unretained(this));
  command_handlers_["Target.setAttachToFrames"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetSetAttachToFrames,
          base::Unretained(this));
  command_handlers_["Target.setRemoteLocations"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetSetRemoteLocations,
          base::Unretained(this));
  command_handlers_["Target.sendMessageToTarget"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetSendMessageToTarget,
          base::Unretained(this));
  command_handlers_["Target.getTargetInfo"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetGetTargetInfo,
          base::Unretained(this));
  command_handlers_["Target.activateTarget"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetActivateTarget,
          base::Unretained(this));
  command_handlers_["Target.closeTarget"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetCloseTarget,
          base::Unretained(this));
  command_handlers_["Target.attachToTarget"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetAttachToTarget,
          base::Unretained(this));
  command_handlers_["Target.detachFromTarget"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetDetachFromTarget,
          base::Unretained(this));
  command_handlers_["Target.createBrowserContext"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetCreateBrowserContext,
          base::Unretained(this));
  command_handlers_["Target.disposeBrowserContext"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetDisposeBrowserContext,
          base::Unretained(this));
  command_handlers_["Target.createTarget"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetCreateTarget,
          base::Unretained(this));
  command_handlers_["Target.getTargets"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTargetGetTargets,
          base::Unretained(this));
  target_handler_->SetClient(base::WrapUnique(
      new devtools::target::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetServiceWorkerHandler(
    devtools::service_worker::ServiceWorkerHandler* service_worker_handler) {
  DCHECK(!service_worker_handler_);
  service_worker_handler_ = service_worker_handler;
  command_handlers_["ServiceWorker.enable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerEnable,
          base::Unretained(this));
  command_handlers_["ServiceWorker.disable"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerDisable,
          base::Unretained(this));
  command_handlers_["ServiceWorker.unregister"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerUnregister,
          base::Unretained(this));
  command_handlers_["ServiceWorker.updateRegistration"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerUpdateRegistration,
          base::Unretained(this));
  command_handlers_["ServiceWorker.startWorker"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerStartWorker,
          base::Unretained(this));
  command_handlers_["ServiceWorker.skipWaiting"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerSkipWaiting,
          base::Unretained(this));
  command_handlers_["ServiceWorker.stopWorker"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerStopWorker,
          base::Unretained(this));
  command_handlers_["ServiceWorker.inspectWorker"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerInspectWorker,
          base::Unretained(this));
  command_handlers_["ServiceWorker.setForceUpdateOnPageLoad"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerSetForceUpdateOnPageLoad,
          base::Unretained(this));
  command_handlers_["ServiceWorker.deliverPushMessage"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerDeliverPushMessage,
          base::Unretained(this));
  command_handlers_["ServiceWorker.dispatchSyncEvent"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnServiceWorkerDispatchSyncEvent,
          base::Unretained(this));
  service_worker_handler_->SetClient(base::WrapUnique(
      new devtools::service_worker::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetInputHandler(
    devtools::input::InputHandler* input_handler) {
  DCHECK(!input_handler_);
  input_handler_ = input_handler;
  command_handlers_["Input.dispatchKeyEvent"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInputDispatchKeyEvent,
          base::Unretained(this));
  command_handlers_["Input.dispatchMouseEvent"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInputDispatchMouseEvent,
          base::Unretained(this));
  command_handlers_["Input.dispatchTouchEvent"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInputDispatchTouchEvent,
          base::Unretained(this));
  command_handlers_["Input.emulateTouchFromMouseEvent"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInputEmulateTouchFromMouseEvent,
          base::Unretained(this));
  command_handlers_["Input.synthesizePinchGesture"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInputSynthesizePinchGesture,
          base::Unretained(this));
  command_handlers_["Input.synthesizeScrollGesture"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInputSynthesizeScrollGesture,
          base::Unretained(this));
  command_handlers_["Input.synthesizeTapGesture"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnInputSynthesizeTapGesture,
          base::Unretained(this));
  input_handler_->SetClient(base::WrapUnique(
      new devtools::input::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetTracingHandler(
    devtools::tracing::TracingHandler* tracing_handler) {
  DCHECK(!tracing_handler_);
  tracing_handler_ = tracing_handler;
  command_handlers_["Tracing.start"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTracingStart,
          base::Unretained(this));
  command_handlers_["Tracing.end"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTracingEnd,
          base::Unretained(this));
  command_handlers_["Tracing.getCategories"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTracingGetCategories,
          base::Unretained(this));
  command_handlers_["Tracing.requestMemoryDump"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTracingRequestMemoryDump,
          base::Unretained(this));
  command_handlers_["Tracing.recordClockSyncMarker"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTracingRecordClockSyncMarker,
          base::Unretained(this));
  tracing_handler_->SetClient(base::WrapUnique(
      new devtools::tracing::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetStorageHandler(
    devtools::storage::StorageHandler* storage_handler) {
  DCHECK(!storage_handler_);
  storage_handler_ = storage_handler;
  command_handlers_["Storage.clearDataForOrigin"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnStorageClearDataForOrigin,
          base::Unretained(this));
}

void DevToolsProtocolDispatcher::SetSystemInfoHandler(
    devtools::system_info::SystemInfoHandler* system_info_handler) {
  DCHECK(!system_info_handler_);
  system_info_handler_ = system_info_handler;
  command_handlers_["SystemInfo.getInfo"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnSystemInfoGetInfo,
          base::Unretained(this));
  system_info_handler_->SetClient(base::WrapUnique(
      new devtools::system_info::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetTetheringHandler(
    devtools::tethering::TetheringHandler* tethering_handler) {
  DCHECK(!tethering_handler_);
  tethering_handler_ = tethering_handler;
  command_handlers_["Tethering.bind"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTetheringBind,
          base::Unretained(this));
  command_handlers_["Tethering.unbind"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnTetheringUnbind,
          base::Unretained(this));
  tethering_handler_->SetClient(base::WrapUnique(
      new devtools::tethering::Client(notifier_)));
}

void DevToolsProtocolDispatcher::SetSchemaHandler(
    devtools::schema::SchemaHandler* schema_handler) {
  DCHECK(!schema_handler_);
  schema_handler_ = schema_handler;
  command_handlers_["Schema.getDomains"] =
      base::Bind(
          &DevToolsProtocolDispatcher::OnSchemaGetDomains,
          base::Unretained(this));
}

namespace devtools {

const char kProtocolVersion[] = "1.2";

bool IsSupportedProtocolVersion(const std::string& version) {
  std::vector<base::StringPiece> tokens = base::SplitStringPiece(
      version, ".", base::KEEP_WHITESPACE, base::SPLIT_WANT_NONEMPTY);
  int major, minor;
  return tokens.size() == 2 &&
      base::StringToInt(tokens[0], &major) && major == 1 &&
      base::StringToInt(tokens[1], &minor) && minor <= 2;
}

template<>
std::unique_ptr<base::Value> CreateValue(const std::string& param) {
  return base::MakeUnique<base::StringValue>(param);
}

namespace inspector {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::Detached(
    scoped_refptr<DetachedParams> params) {
  SendNotification("Inspector.detached",
                   params->ToValue());
}

void Client::TargetCrashed(
    scoped_refptr<TargetCrashedParams> params) {
  SendNotification("Inspector.targetCrashed",
                   params->ToValue());
}

}  // namespace inspector

namespace memory {
const char kPressureLevelModerate[] = "moderate";
const char kPressureLevelCritical[] = "critical";
}  // namespace memory

namespace page {
const char kResourceTypeDocument[] = "Document";
const char kResourceTypeStylesheet[] = "Stylesheet";
const char kResourceTypeImage[] = "Image";
const char kResourceTypeMedia[] = "Media";
const char kResourceTypeFont[] = "Font";
const char kResourceTypeScript[] = "Script";
const char kResourceTypeTextTrack[] = "TextTrack";
const char kResourceTypeXHR[] = "XHR";
const char kResourceTypeFetch[] = "Fetch";
const char kResourceTypeEventSource[] = "EventSource";
const char kResourceTypeWebSocket[] = "WebSocket";
const char kResourceTypeManifest[] = "Manifest";
const char kResourceTypeOther[] = "Other";
}  // namespace page

namespace page {
namespace start_screencast {
const char kFormatJpeg[] = "jpeg";
const char kFormatPng[] = "png";
}  // namespace start_screencast
}  // namespace page

namespace page {
const char kNavigationResponseProceed[] = "Proceed";
const char kNavigationResponseCancel[] = "Cancel";
const char kNavigationResponseCancelAndIgnore[] = "CancelAndIgnore";
}  // namespace page

namespace page {
const char kDialogTypeAlert[] = "alert";
const char kDialogTypeConfirm[] = "confirm";
const char kDialogTypePrompt[] = "prompt";
const char kDialogTypeBeforeunload[] = "beforeunload";
}  // namespace page

namespace page {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::SendGetResourceContentResponse(
    DevToolsCommandId command_id,
    scoped_refptr<GetResourceContentResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendSearchInResourceResponse(
    DevToolsCommandId command_id,
    scoped_refptr<SearchInResourceResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendCaptureScreenshotResponse(
    DevToolsCommandId command_id,
    scoped_refptr<CaptureScreenshotResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::DomContentEventFired(
    scoped_refptr<DomContentEventFiredParams> params) {
  SendNotification("Page.domContentEventFired",
                   params->ToValue());
}

void Client::LoadEventFired(
    scoped_refptr<LoadEventFiredParams> params) {
  SendNotification("Page.loadEventFired",
                   params->ToValue());
}

void Client::FrameAttached(
    scoped_refptr<FrameAttachedParams> params) {
  SendNotification("Page.frameAttached",
                   params->ToValue());
}

void Client::FrameNavigated(
    scoped_refptr<FrameNavigatedParams> params) {
  SendNotification("Page.frameNavigated",
                   params->ToValue());
}

void Client::FrameDetached(
    scoped_refptr<FrameDetachedParams> params) {
  SendNotification("Page.frameDetached",
                   params->ToValue());
}

void Client::FrameStartedLoading(
    scoped_refptr<FrameStartedLoadingParams> params) {
  SendNotification("Page.frameStartedLoading",
                   params->ToValue());
}

void Client::FrameStoppedLoading(
    scoped_refptr<FrameStoppedLoadingParams> params) {
  SendNotification("Page.frameStoppedLoading",
                   params->ToValue());
}

void Client::FrameScheduledNavigation(
    scoped_refptr<FrameScheduledNavigationParams> params) {
  SendNotification("Page.frameScheduledNavigation",
                   params->ToValue());
}

void Client::FrameClearedScheduledNavigation(
    scoped_refptr<FrameClearedScheduledNavigationParams> params) {
  SendNotification("Page.frameClearedScheduledNavigation",
                   params->ToValue());
}

void Client::FrameResized(
    scoped_refptr<FrameResizedParams> params) {
  SendNotification("Page.frameResized",
                   params->ToValue());
}

void Client::JavascriptDialogOpening(
    scoped_refptr<JavascriptDialogOpeningParams> params) {
  SendNotification("Page.javascriptDialogOpening",
                   params->ToValue());
}

void Client::JavascriptDialogClosed(
    scoped_refptr<JavascriptDialogClosedParams> params) {
  SendNotification("Page.javascriptDialogClosed",
                   params->ToValue());
}

void Client::ScreencastFrame(
    scoped_refptr<ScreencastFrameParams> params) {
  SendNotification("Page.screencastFrame",
                   params->ToValue());
}

void Client::ScreencastVisibilityChanged(
    scoped_refptr<ScreencastVisibilityChangedParams> params) {
  SendNotification("Page.screencastVisibilityChanged",
                   params->ToValue());
}

void Client::ColorPicked(
    scoped_refptr<ColorPickedParams> params) {
  SendNotification("Page.colorPicked",
                   params->ToValue());
}

void Client::InterstitialShown(
    scoped_refptr<InterstitialShownParams> params) {
  SendNotification("Page.interstitialShown",
                   params->ToValue());
}

void Client::InterstitialHidden(
    scoped_refptr<InterstitialHiddenParams> params) {
  SendNotification("Page.interstitialHidden",
                   params->ToValue());
}

void Client::NavigationRequested(
    scoped_refptr<NavigationRequestedParams> params) {
  SendNotification("Page.navigationRequested",
                   params->ToValue());
}

}  // namespace page

namespace emulation {
namespace screen_orientation {
const char kTypePortraitPrimary[] = "portraitPrimary";
const char kTypePortraitSecondary[] = "portraitSecondary";
const char kTypeLandscapePrimary[] = "landscapePrimary";
const char kTypeLandscapeSecondary[] = "landscapeSecondary";
}  // namespace screen_orientation
}  // namespace emulation

namespace emulation {
namespace set_touch_emulation_enabled {
const char kConfigurationMobile[] = "mobile";
const char kConfigurationDesktop[] = "desktop";
}  // namespace set_touch_emulation_enabled
}  // namespace emulation

namespace emulation {
const char kVirtualTimePolicyAdvance[] = "advance";
const char kVirtualTimePolicyPause[] = "pause";
const char kVirtualTimePolicyPauseIfNetworkFetchesPending[] = "pauseIfNetworkFetchesPending";
}  // namespace emulation

namespace emulation {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::VirtualTimeBudgetExpired(
    scoped_refptr<VirtualTimeBudgetExpiredParams> params) {
  SendNotification("Emulation.virtualTimeBudgetExpired",
                   params->ToValue());
}

}  // namespace emulation

namespace security {
const char kSecurityStateUnknown[] = "unknown";
const char kSecurityStateNeutral[] = "neutral";
const char kSecurityStateInsecure[] = "insecure";
const char kSecurityStateWarning[] = "warning";
const char kSecurityStateSecure[] = "secure";
const char kSecurityStateInfo[] = "info";
}  // namespace security

namespace security {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::SecurityStateChanged(
    scoped_refptr<SecurityStateChangedParams> params) {
  SendNotification("Security.securityStateChanged",
                   params->ToValue());
}

}  // namespace security

namespace network {
const char kCookieSameSiteStrict[] = "Strict";
const char kCookieSameSiteLax[] = "Lax";
}  // namespace network

namespace network {
const char kConnectionTypeNone[] = "none";
const char kConnectionTypeCellular2g[] = "cellular2g";
const char kConnectionTypeCellular3g[] = "cellular3g";
const char kConnectionTypeCellular4g[] = "cellular4g";
const char kConnectionTypeBluetooth[] = "bluetooth";
const char kConnectionTypeEthernet[] = "ethernet";
const char kConnectionTypeWifi[] = "wifi";
const char kConnectionTypeWimax[] = "wimax";
const char kConnectionTypeOther[] = "other";
}  // namespace network

namespace network {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::SendGetCookiesResponse(
    DevToolsCommandId command_id,
    scoped_refptr<GetCookiesResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendDeleteCookieResponse(
    DevToolsCommandId command_id,
    scoped_refptr<DeleteCookieResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendSetCookieResponse(
    DevToolsCommandId command_id,
    scoped_refptr<SetCookieResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

}  // namespace network

namespace io {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::SendReadResponse(
    DevToolsCommandId command_id,
    scoped_refptr<ReadResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

}  // namespace io

namespace target {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::TargetCreated(
    scoped_refptr<TargetCreatedParams> params) {
  SendNotification("Target.targetCreated",
                   params->ToValue());
}

void Client::TargetDestroyed(
    scoped_refptr<TargetDestroyedParams> params) {
  SendNotification("Target.targetDestroyed",
                   params->ToValue());
}

void Client::AttachedToTarget(
    scoped_refptr<AttachedToTargetParams> params) {
  SendNotification("Target.attachedToTarget",
                   params->ToValue());
}

void Client::DetachedFromTarget(
    scoped_refptr<DetachedFromTargetParams> params) {
  SendNotification("Target.detachedFromTarget",
                   params->ToValue());
}

void Client::ReceivedMessageFromTarget(
    scoped_refptr<ReceivedMessageFromTargetParams> params) {
  SendNotification("Target.receivedMessageFromTarget",
                   params->ToValue());
}

}  // namespace target

namespace service_worker {
const char kServiceWorkerVersionRunningStatusStopped[] = "stopped";
const char kServiceWorkerVersionRunningStatusStarting[] = "starting";
const char kServiceWorkerVersionRunningStatusRunning[] = "running";
const char kServiceWorkerVersionRunningStatusStopping[] = "stopping";
}  // namespace service_worker

namespace service_worker {
const char kServiceWorkerVersionStatusNew[] = "new";
const char kServiceWorkerVersionStatusInstalling[] = "installing";
const char kServiceWorkerVersionStatusInstalled[] = "installed";
const char kServiceWorkerVersionStatusActivating[] = "activating";
const char kServiceWorkerVersionStatusActivated[] = "activated";
const char kServiceWorkerVersionStatusRedundant[] = "redundant";
}  // namespace service_worker

namespace service_worker {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::WorkerRegistrationUpdated(
    scoped_refptr<WorkerRegistrationUpdatedParams> params) {
  SendNotification("ServiceWorker.workerRegistrationUpdated",
                   params->ToValue());
}

void Client::WorkerVersionUpdated(
    scoped_refptr<WorkerVersionUpdatedParams> params) {
  SendNotification("ServiceWorker.workerVersionUpdated",
                   params->ToValue());
}

void Client::WorkerErrorReported(
    scoped_refptr<WorkerErrorReportedParams> params) {
  SendNotification("ServiceWorker.workerErrorReported",
                   params->ToValue());
}

}  // namespace service_worker

namespace input {
namespace dispatch_key_event {
const char kTypeKeyDown[] = "keyDown";
const char kTypeKeyUp[] = "keyUp";
const char kTypeRawKeyDown[] = "rawKeyDown";
const char kTypeChar[] = "char";
}  // namespace dispatch_key_event
}  // namespace input

namespace input {
namespace dispatch_mouse_event {
const char kTypeMousePressed[] = "mousePressed";
const char kTypeMouseReleased[] = "mouseReleased";
const char kTypeMouseMoved[] = "mouseMoved";
}  // namespace dispatch_mouse_event
}  // namespace input

namespace input {
namespace dispatch_mouse_event {
const char kButtonNone[] = "none";
const char kButtonLeft[] = "left";
const char kButtonMiddle[] = "middle";
const char kButtonRight[] = "right";
}  // namespace dispatch_mouse_event
}  // namespace input

namespace input {
namespace dispatch_touch_event {
const char kTypeTouchStart[] = "touchStart";
const char kTypeTouchEnd[] = "touchEnd";
const char kTypeTouchMove[] = "touchMove";
}  // namespace dispatch_touch_event
}  // namespace input

namespace input {
namespace touch_point {
const char kStateTouchPressed[] = "touchPressed";
const char kStateTouchReleased[] = "touchReleased";
const char kStateTouchMoved[] = "touchMoved";
const char kStateTouchStationary[] = "touchStationary";
const char kStateTouchCancelled[] = "touchCancelled";
}  // namespace touch_point
}  // namespace input

namespace input {
namespace emulate_touch_from_mouse_event {
const char kTypeMousePressed[] = "mousePressed";
const char kTypeMouseReleased[] = "mouseReleased";
const char kTypeMouseMoved[] = "mouseMoved";
const char kTypeMouseWheel[] = "mouseWheel";
}  // namespace emulate_touch_from_mouse_event
}  // namespace input

namespace input {
namespace emulate_touch_from_mouse_event {
const char kButtonNone[] = "none";
const char kButtonLeft[] = "left";
const char kButtonMiddle[] = "middle";
const char kButtonRight[] = "right";
}  // namespace emulate_touch_from_mouse_event
}  // namespace input

namespace input {
const char kGestureSourceTypeDefault[] = "default";
const char kGestureSourceTypeTouch[] = "touch";
const char kGestureSourceTypeMouse[] = "mouse";
}  // namespace input

namespace input {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::SendSynthesizePinchGestureResponse(
    DevToolsCommandId command_id,
    scoped_refptr<SynthesizePinchGestureResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendSynthesizeScrollGestureResponse(
    DevToolsCommandId command_id,
    scoped_refptr<SynthesizeScrollGestureResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendSynthesizeTapGestureResponse(
    DevToolsCommandId command_id,
    scoped_refptr<SynthesizeTapGestureResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

}  // namespace input

namespace tracing {
namespace start {
const char kTransferModeReportEvents[] = "ReportEvents";
const char kTransferModeReturnAsStream[] = "ReturnAsStream";
}  // namespace start
}  // namespace tracing

namespace tracing {
namespace trace_config {
const char kRecordModeRecordUntilFull[] = "recordUntilFull";
const char kRecordModeRecordContinuously[] = "recordContinuously";
const char kRecordModeRecordAsMuchAsPossible[] = "recordAsMuchAsPossible";
const char kRecordModeEchoToConsole[] = "echoToConsole";
}  // namespace trace_config
}  // namespace tracing

namespace tracing {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::SendStartResponse(
    DevToolsCommandId command_id,
    scoped_refptr<StartResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendEndResponse(
    DevToolsCommandId command_id,
    scoped_refptr<EndResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendGetCategoriesResponse(
    DevToolsCommandId command_id,
    scoped_refptr<GetCategoriesResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendRequestMemoryDumpResponse(
    DevToolsCommandId command_id,
    scoped_refptr<RequestMemoryDumpResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::DataCollected(
    scoped_refptr<DataCollectedParams> params) {
  SendNotification("Tracing.dataCollected",
                   params->ToValue());
}

void Client::TracingComplete(
    scoped_refptr<TracingCompleteParams> params) {
  SendNotification("Tracing.tracingComplete",
                   params->ToValue());
}

void Client::BufferUsage(
    scoped_refptr<BufferUsageParams> params) {
  SendNotification("Tracing.bufferUsage",
                   params->ToValue());
}

}  // namespace tracing

namespace system_info {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::SendGetInfoResponse(
    DevToolsCommandId command_id,
    scoped_refptr<GetInfoResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

}  // namespace system_info

namespace tethering {

Client::Client(DevToolsProtocolDelegate* notifier)
    : DevToolsProtocolClient(notifier) {
}

Client::~Client() {
}

void Client::SendBindResponse(
    DevToolsCommandId command_id,
    scoped_refptr<BindResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::SendUnbindResponse(
    DevToolsCommandId command_id,
    scoped_refptr<UnbindResponse> params) {
  SendSuccess(command_id, params->ToValue());
}

void Client::Accepted(
    scoped_refptr<AcceptedParams> params) {
  SendNotification("Tethering.accepted",
                   params->ToValue());
}

}  // namespace tethering

}  // namespace devtools

}  // namespace content
