// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_INDEXED_DB_INDEXED_DB_MOJOM_H_
#define CONTENT_COMMON_INDEXED_DB_INDEXED_DB_MOJOM_H_

#include <stdint.h>

#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/lib/union_accessor.h"
#include "mojo/public/cpp/bindings/map.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/no_interface.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/common/indexed_db/indexed_db.mojom-shared.h"
#include "mojo/common/common_custom_types.mojom.h"
#include "url/mojo/origin.mojom.h"
#include "mojo/public/cpp/bindings/array.h"
#include "mojo/public/cpp/bindings/string.h"
#include "gpu/config/dx_diag_node.h"
#include "ui/gfx/geometry/point_f.h"
#include "ui/gfx/geometry/vector2d_f.h"
#include "content/common/indexed_db/indexed_db_key_range.h"
#include "ui/gfx/geometry/insets.h"
#include "gpu/command_buffer/common/capabilities.h"
#include "media/base/demuxer_stream.h"
#include "content/common/indexed_db/indexed_db_key.h"
#include "base/values.h"
#include "cc/output/compositor_frame_metadata.h"
#include "media/base/audio_codecs.h"
#include "ui/gfx/geometry/rect_f.h"
#include "content/common/resize_params.h"
#include "media/base/cdm_promise.h"
#include "content/common/indexed_db/indexed_db_metadata.h"
#include "media/base/buffering_state.h"
#include "url/origin.h"
#include "cc/output/compositor_frame.h"
#include "base/unguessable_token.h"
#include "third_party/WebKit/public/platform/WebReferrerPolicy.h"
#include "ui/gfx/geometry/safe_integer_conversions.h"
#include "ui/base/window_open_disposition.h"
#include "cc/quads/shared_quad_state.h"
#include "gpu/ipc/common/surface_handle.h"
#include "net/url_request/redirect_info.h"
#include "content/common/service_worker/service_worker_status_code.h"
#include "gpu/command_buffer/common/sync_token.h"
#include "cc/output/filter_operations.h"
#include "media/capture/video_capture_types.h"
#include "gpu/config/gpu_info.h"
#include "cc/quads/render_pass_id.h"
#include "ui/gfx/gpu_memory_buffer.h"
#include "ui/events/event.h"
#include "media/base/sample_format.h"
#include "media/base/eme_constants.h"
#include "media/base/video_codecs.h"
#include "third_party/WebKit/public/platform/modules/indexeddb/WebIDBTypes.h"
#include "media/base/encryption_scheme.h"
#include "cc/output/begin_frame_args.h"
#include "third_party/WebKit/public/web/WebPopupType.h"
#include "media/base/cdm_key_information.h"
#include "cc/quads/draw_quad.h"
#include "media/base/audio_parameters.h"
#include "cc/resources/returned_resource.h"
#include "content/common/frame_owner_properties.h"
#include "gpu/command_buffer/common/mailbox.h"
#include "media/base/pipeline_status.h"
#include "services/service_manager/public/cpp/service_info.h"
#include "url/gurl.h"
#include "cc/resources/transferable_resource.h"
#include "cc/surfaces/local_frame_id.h"
#include "media/capture/video/video_capture_device_descriptor.h"
#include "cc/surfaces/surface_sequence.h"
#include "content/public/common/renderer_preferences.h"
#include "media/base/decryptor.h"
#include "cc/output/filter_operation.h"
#include "ui/gfx/icc_profile.h"
#include "third_party/WebKit/public/web/WebWindowFeatures.h"
#include "content/public/common/media_metadata.h"
#include "services/service_manager/public/cpp/identity.h"
#include "content/common/bluetooth/web_bluetooth_device_id.h"
#include "ui/gfx/geometry/size.h"
#include "cc/input/selection.h"
#include "content/public/common/referrer.h"
#include "ui/events/latency_info.h"
#include "content/public/common/web_preferences.h"
#include "cc/quads/render_pass.h"
#include "ui/gfx/native_pixmap_handle.h"
#include "media/base/subsample_entry.h"
#include "content/common/media/media_devices.h"
#include "cc/surfaces/frame_sink_id.h"
#include "ui/gfx/transform.h"
#include "device/bluetooth/bluetooth_uuid.h"
#include "content/common/resource_request_completion_status.h"
#include "ui/gfx/geometry/rect.h"
#include "cc/surfaces/surface_id.h"
#include "media/base/channel_layout.h"
#include "ui/gfx/geometry/vector2d.h"
#include "services/video_capture/public/cpp/capture_settings.h"
#include "services/service_manager/public/cpp/interface_provider_spec.h"
#include "content/common/service_worker/embedded_worker_start_params.h"
#include "third_party/skia/include/core/SkImageFilter.h"
#include "media/base/media_keys.h"
#include "ui/display/display.h"
#include "base/version.h"
#include "base/time/time.h"
#include "base/strings/string16.h"
#include "ui/gfx/selection_bound.h"
#include "ui/gfx/geometry/point.h"
#include "content/public/common/resource_response.h"
#include "base/files/file_path.h"
#include "gpu/command_buffer/common/mailbox_holder.h"
#include "net/base/network_change_notifier.h"
#include "ui/gfx/buffer_types.h"
#include "content/common/indexed_db/indexed_db_key_path.h"
#include "third_party/skia/include/core/SkBitmap.h"
#include "content/common/frame_replication_state.h"
#include "ui/gfx/native_widget_types.h"
#include "media/base/decode_status.h"
#include "content/common/resource_request.h"
#include "content/common/service_worker/service_worker_types.h"
#include "media/base/video_types.h"
#include "content/common/content_export.h"


namespace indexed_db {
namespace mojom {
class Callbacks;
using CallbacksPtr = mojo::InterfacePtr<Callbacks>;
using CallbacksPtrInfo = mojo::InterfacePtrInfo<Callbacks>;
using ThreadSafeCallbacksPtr =
    mojo::ThreadSafeInterfacePtr<Callbacks>;
using CallbacksRequest = mojo::InterfaceRequest<Callbacks>;
using CallbacksAssociatedPtr =
    mojo::AssociatedInterfacePtr<Callbacks>;
using ThreadSafeCallbacksAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<Callbacks>;
using CallbacksAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<Callbacks>;
using CallbacksAssociatedRequest =
    mojo::AssociatedInterfaceRequest<Callbacks>;

class DatabaseCallbacks;
using DatabaseCallbacksPtr = mojo::InterfacePtr<DatabaseCallbacks>;
using DatabaseCallbacksPtrInfo = mojo::InterfacePtrInfo<DatabaseCallbacks>;
using ThreadSafeDatabaseCallbacksPtr =
    mojo::ThreadSafeInterfacePtr<DatabaseCallbacks>;
using DatabaseCallbacksRequest = mojo::InterfaceRequest<DatabaseCallbacks>;
using DatabaseCallbacksAssociatedPtr =
    mojo::AssociatedInterfacePtr<DatabaseCallbacks>;
using ThreadSafeDatabaseCallbacksAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<DatabaseCallbacks>;
using DatabaseCallbacksAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<DatabaseCallbacks>;
using DatabaseCallbacksAssociatedRequest =
    mojo::AssociatedInterfaceRequest<DatabaseCallbacks>;

class Database;
using DatabasePtr = mojo::InterfacePtr<Database>;
using DatabasePtrInfo = mojo::InterfacePtrInfo<Database>;
using ThreadSafeDatabasePtr =
    mojo::ThreadSafeInterfacePtr<Database>;
using DatabaseRequest = mojo::InterfaceRequest<Database>;
using DatabaseAssociatedPtr =
    mojo::AssociatedInterfacePtr<Database>;
using ThreadSafeDatabaseAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<Database>;
using DatabaseAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<Database>;
using DatabaseAssociatedRequest =
    mojo::AssociatedInterfaceRequest<Database>;

class Factory;
using FactoryPtr = mojo::InterfacePtr<Factory>;
using FactoryPtrInfo = mojo::InterfacePtrInfo<Factory>;
using ThreadSafeFactoryPtr =
    mojo::ThreadSafeInterfacePtr<Factory>;
using FactoryRequest = mojo::InterfaceRequest<Factory>;
using FactoryAssociatedPtr =
    mojo::AssociatedInterfacePtr<Factory>;
using ThreadSafeFactoryAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<Factory>;
using FactoryAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<Factory>;
using FactoryAssociatedRequest =
    mojo::AssociatedInterfaceRequest<Factory>;

using Key = mojo::NativeStruct;
using KeyPtr = mojo::NativeStructPtr;

using KeyPath = mojo::NativeStruct;
using KeyPathPtr = mojo::NativeStructPtr;

using KeyRange = mojo::NativeStruct;
using KeyRangePtr = mojo::NativeStructPtr;

class IndexMetadata;
using IndexMetadataPtr = mojo::StructPtr<IndexMetadata>;

class ObjectStoreMetadata;
using ObjectStoreMetadataPtr = mojo::StructPtr<ObjectStoreMetadata>;

class DatabaseMetadata;
using DatabaseMetadataPtr = mojo::StructPtr<DatabaseMetadata>;

class IndexKeys;
using IndexKeysPtr = mojo::StructPtr<IndexKeys>;

class FileInfo;
using FileInfoPtr = mojo::StructPtr<FileInfo>;

class BlobInfo;
using BlobInfoPtr = mojo::StructPtr<BlobInfo>;

class Value;
using ValuePtr = mojo::StructPtr<Value>;

class ReturnValue;
using ReturnValuePtr = mojo::StructPtr<ReturnValue>;


class CallbacksProxy;

template <typename ImplRefTraits>
class CallbacksStub;

class CallbacksRequestValidator;

class CONTENT_EXPORT Callbacks
    : public CallbacksInterfaceBase {
 public:
  static const char Name_[];
  static const uint32_t Version_ = 0;
  static const bool PassesAssociatedKinds_ = true;
  static const bool HasSyncMethods_ = false;

  using Proxy_ = CallbacksProxy;

  template <typename ImplRefTraits>
  using Stub_ = CallbacksStub<ImplRefTraits>;

  using RequestValidator_ = CallbacksRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  virtual ~Callbacks() {}

  virtual void Error(int32_t code, const base::string16& message) = 0;

  virtual void SuccessStringList(const std::vector<base::string16>& value) = 0;

  virtual void Blocked(int64_t existing_version) = 0;

  virtual void UpgradeNeeded(DatabaseAssociatedPtrInfo database, int64_t old_version, blink::WebIDBDataLoss data_loss, const std::string& data_loss_message, const content::IndexedDBDatabaseMetadata& db_metadata) = 0;

  virtual void SuccessDatabase(DatabaseAssociatedPtrInfo database, const content::IndexedDBDatabaseMetadata& metadata) = 0;

  virtual void SuccessCursor(int32_t cursor_id, const content::IndexedDBKey& key, const content::IndexedDBKey& primary_key, ValuePtr value) = 0;

  virtual void SuccessValue(ReturnValuePtr value) = 0;

  virtual void SuccessArray(std::vector<ReturnValuePtr> values) = 0;

  virtual void SuccessKey(const content::IndexedDBKey& key) = 0;

  virtual void SuccessInteger(int64_t value) = 0;

  virtual void Success() = 0;
};

class DatabaseCallbacksProxy;

template <typename ImplRefTraits>
class DatabaseCallbacksStub;

class DatabaseCallbacksRequestValidator;

class CONTENT_EXPORT DatabaseCallbacks
    : public DatabaseCallbacksInterfaceBase {
 public:
  static const char Name_[];
  static const uint32_t Version_ = 0;
  static const bool PassesAssociatedKinds_ = false;
  static const bool HasSyncMethods_ = false;

  using Proxy_ = DatabaseCallbacksProxy;

  template <typename ImplRefTraits>
  using Stub_ = DatabaseCallbacksStub<ImplRefTraits>;

  using RequestValidator_ = DatabaseCallbacksRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  virtual ~DatabaseCallbacks() {}

  virtual void ForcedClose() = 0;

  virtual void VersionChange(int64_t old_version, int64_t new_version) = 0;

  virtual void Abort(int64_t transaction_id, int32_t code, const base::string16& message) = 0;

  virtual void Complete(int64_t transaction_id) = 0;
};

class DatabaseProxy;

template <typename ImplRefTraits>
class DatabaseStub;

class DatabaseRequestValidator;

class CONTENT_EXPORT Database
    : public DatabaseInterfaceBase {
 public:
  static const char Name_[];
  static const uint32_t Version_ = 0;
  static const bool PassesAssociatedKinds_ = true;
  static const bool HasSyncMethods_ = false;

  using Proxy_ = DatabaseProxy;

  template <typename ImplRefTraits>
  using Stub_ = DatabaseStub<ImplRefTraits>;

  using RequestValidator_ = DatabaseRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  virtual ~Database() {}

  virtual void CreateObjectStore(int64_t transaction_id, int64_t object_store_id, const base::string16& name, const content::IndexedDBKeyPath& key_path, bool auto_increment) = 0;

  virtual void DeleteObjectStore(int64_t transaction_id, int64_t object_store_id) = 0;

  virtual void RenameObjectStore(int64_t transaction_id, int64_t object_store_id, const base::string16& new_name) = 0;

  virtual void CreateTransaction(int64_t transaction_id, const std::vector<int64_t>& object_store_ids, blink::WebIDBTransactionMode mode) = 0;

  virtual void Close() = 0;

  virtual void VersionChangeIgnored() = 0;

  virtual void AddObserver(int64_t transaction_id, int32_t observer_id, bool include_transaction, bool no_records, bool values, uint16_t operation_types) = 0;

  virtual void RemoveObservers(const std::vector<int32_t>& observers) = 0;

  virtual void Get(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const content::IndexedDBKeyRange& key_range, bool key_only, CallbacksAssociatedPtrInfo callbacks) = 0;

  virtual void GetAll(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const content::IndexedDBKeyRange& key_range, bool key_only, int64_t max_count, CallbacksAssociatedPtrInfo callbacks) = 0;

  virtual void Put(int64_t transaction_id, int64_t object_store_id, ValuePtr value, const content::IndexedDBKey& key, blink::WebIDBPutMode mode, const std::vector<content::IndexedDBIndexKeys>& index_keys, CallbacksAssociatedPtrInfo callbacks) = 0;

  virtual void SetIndexKeys(int64_t transaction_id, int64_t object_store_id, const content::IndexedDBKey& primary_key, const std::vector<content::IndexedDBIndexKeys>& index_keys) = 0;

  virtual void SetIndexesReady(int64_t transaction_id, int64_t object_store_id, const std::vector<int64_t>& index_ids) = 0;

  virtual void OpenCursor(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const content::IndexedDBKeyRange& key_range, blink::WebIDBCursorDirection direction, bool key_only, blink::WebIDBTaskType task_type, CallbacksAssociatedPtrInfo callbacks) = 0;

  virtual void Count(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const content::IndexedDBKeyRange& key_range, CallbacksAssociatedPtrInfo callbacks) = 0;

  virtual void DeleteRange(int64_t transaction_id, int64_t object_store_id, const content::IndexedDBKeyRange& key_range, CallbacksAssociatedPtrInfo callbacks) = 0;

  virtual void Clear(int64_t transaction_id, int64_t object_store_id, CallbacksAssociatedPtrInfo callbacks) = 0;

  virtual void CreateIndex(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const base::string16& name, const content::IndexedDBKeyPath& key_path, bool unique, bool multi_entry) = 0;

  virtual void DeleteIndex(int64_t transaction_id, int64_t object_store_id, int64_t index_id) = 0;

  virtual void RenameIndex(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const base::string16& new_name) = 0;

  virtual void Abort(int64_t transaction_id) = 0;

  virtual void Commit(int64_t transaction_id) = 0;

  virtual void AckReceivedBlobs(const std::vector<std::string>& uuids) = 0;
};

class FactoryProxy;

template <typename ImplRefTraits>
class FactoryStub;

class FactoryRequestValidator;

class CONTENT_EXPORT Factory
    : public FactoryInterfaceBase {
 public:
  static const char Name_[];
  static const uint32_t Version_ = 0;
  static const bool PassesAssociatedKinds_ = true;
  static const bool HasSyncMethods_ = false;

  using Proxy_ = FactoryProxy;

  template <typename ImplRefTraits>
  using Stub_ = FactoryStub<ImplRefTraits>;

  using RequestValidator_ = FactoryRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  virtual ~Factory() {}

  virtual void GetDatabaseNames(CallbacksAssociatedPtrInfo callbacks, const url::Origin& origin) = 0;

  virtual void Open(int32_t worker_thread, CallbacksAssociatedPtrInfo callbacks, DatabaseCallbacksAssociatedPtrInfo database_callbacks, const url::Origin& origin, const base::string16& name, int64_t version, int64_t transaction_id) = 0;

  virtual void DeleteDatabase(CallbacksAssociatedPtrInfo callbacks, const url::Origin& origin, const base::string16& name) = 0;
};

class CONTENT_EXPORT CallbacksProxy
    : public Callbacks {
 public:
  explicit CallbacksProxy(mojo::MessageReceiverWithResponder* receiver);
  void Error(int32_t code, const base::string16& message) override;
  void SuccessStringList(const std::vector<base::string16>& value) override;
  void Blocked(int64_t existing_version) override;
  void UpgradeNeeded(DatabaseAssociatedPtrInfo database, int64_t old_version, blink::WebIDBDataLoss data_loss, const std::string& data_loss_message, const content::IndexedDBDatabaseMetadata& db_metadata) override;
  void SuccessDatabase(DatabaseAssociatedPtrInfo database, const content::IndexedDBDatabaseMetadata& metadata) override;
  void SuccessCursor(int32_t cursor_id, const content::IndexedDBKey& key, const content::IndexedDBKey& primary_key, ValuePtr value) override;
  void SuccessValue(ReturnValuePtr value) override;
  void SuccessArray(std::vector<ReturnValuePtr> values) override;
  void SuccessKey(const content::IndexedDBKey& key) override;
  void SuccessInteger(int64_t value) override;
  void Success() override;

  void set_group_controller(
        scoped_refptr<mojo::AssociatedGroupController> group_controller) {
    group_controller_ = std::move(group_controller);
  }
 private:
  mojo::MessageReceiverWithResponder* receiver_;
  scoped_refptr<mojo::AssociatedGroupController> group_controller_;
};

class CONTENT_EXPORT DatabaseCallbacksProxy
    : public DatabaseCallbacks {
 public:
  explicit DatabaseCallbacksProxy(mojo::MessageReceiverWithResponder* receiver);
  void ForcedClose() override;
  void VersionChange(int64_t old_version, int64_t new_version) override;
  void Abort(int64_t transaction_id, int32_t code, const base::string16& message) override;
  void Complete(int64_t transaction_id) override;

  void set_group_controller(
        scoped_refptr<mojo::AssociatedGroupController> group_controller) {
    group_controller_ = std::move(group_controller);
  }
 private:
  mojo::MessageReceiverWithResponder* receiver_;
  scoped_refptr<mojo::AssociatedGroupController> group_controller_;
};

class CONTENT_EXPORT DatabaseProxy
    : public Database {
 public:
  explicit DatabaseProxy(mojo::MessageReceiverWithResponder* receiver);
  void CreateObjectStore(int64_t transaction_id, int64_t object_store_id, const base::string16& name, const content::IndexedDBKeyPath& key_path, bool auto_increment) override;
  void DeleteObjectStore(int64_t transaction_id, int64_t object_store_id) override;
  void RenameObjectStore(int64_t transaction_id, int64_t object_store_id, const base::string16& new_name) override;
  void CreateTransaction(int64_t transaction_id, const std::vector<int64_t>& object_store_ids, blink::WebIDBTransactionMode mode) override;
  void Close() override;
  void VersionChangeIgnored() override;
  void AddObserver(int64_t transaction_id, int32_t observer_id, bool include_transaction, bool no_records, bool values, uint16_t operation_types) override;
  void RemoveObservers(const std::vector<int32_t>& observers) override;
  void Get(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const content::IndexedDBKeyRange& key_range, bool key_only, CallbacksAssociatedPtrInfo callbacks) override;
  void GetAll(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const content::IndexedDBKeyRange& key_range, bool key_only, int64_t max_count, CallbacksAssociatedPtrInfo callbacks) override;
  void Put(int64_t transaction_id, int64_t object_store_id, ValuePtr value, const content::IndexedDBKey& key, blink::WebIDBPutMode mode, const std::vector<content::IndexedDBIndexKeys>& index_keys, CallbacksAssociatedPtrInfo callbacks) override;
  void SetIndexKeys(int64_t transaction_id, int64_t object_store_id, const content::IndexedDBKey& primary_key, const std::vector<content::IndexedDBIndexKeys>& index_keys) override;
  void SetIndexesReady(int64_t transaction_id, int64_t object_store_id, const std::vector<int64_t>& index_ids) override;
  void OpenCursor(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const content::IndexedDBKeyRange& key_range, blink::WebIDBCursorDirection direction, bool key_only, blink::WebIDBTaskType task_type, CallbacksAssociatedPtrInfo callbacks) override;
  void Count(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const content::IndexedDBKeyRange& key_range, CallbacksAssociatedPtrInfo callbacks) override;
  void DeleteRange(int64_t transaction_id, int64_t object_store_id, const content::IndexedDBKeyRange& key_range, CallbacksAssociatedPtrInfo callbacks) override;
  void Clear(int64_t transaction_id, int64_t object_store_id, CallbacksAssociatedPtrInfo callbacks) override;
  void CreateIndex(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const base::string16& name, const content::IndexedDBKeyPath& key_path, bool unique, bool multi_entry) override;
  void DeleteIndex(int64_t transaction_id, int64_t object_store_id, int64_t index_id) override;
  void RenameIndex(int64_t transaction_id, int64_t object_store_id, int64_t index_id, const base::string16& new_name) override;
  void Abort(int64_t transaction_id) override;
  void Commit(int64_t transaction_id) override;
  void AckReceivedBlobs(const std::vector<std::string>& uuids) override;

  void set_group_controller(
        scoped_refptr<mojo::AssociatedGroupController> group_controller) {
    group_controller_ = std::move(group_controller);
  }
 private:
  mojo::MessageReceiverWithResponder* receiver_;
  scoped_refptr<mojo::AssociatedGroupController> group_controller_;
};

class CONTENT_EXPORT FactoryProxy
    : public Factory {
 public:
  explicit FactoryProxy(mojo::MessageReceiverWithResponder* receiver);
  void GetDatabaseNames(CallbacksAssociatedPtrInfo callbacks, const url::Origin& origin) override;
  void Open(int32_t worker_thread, CallbacksAssociatedPtrInfo callbacks, DatabaseCallbacksAssociatedPtrInfo database_callbacks, const url::Origin& origin, const base::string16& name, int64_t version, int64_t transaction_id) override;
  void DeleteDatabase(CallbacksAssociatedPtrInfo callbacks, const url::Origin& origin, const base::string16& name) override;

  void set_group_controller(
        scoped_refptr<mojo::AssociatedGroupController> group_controller) {
    group_controller_ = std::move(group_controller);
  }
 private:
  mojo::MessageReceiverWithResponder* receiver_;
  scoped_refptr<mojo::AssociatedGroupController> group_controller_;
};
class CONTENT_EXPORT CallbacksStubDispatch {
 public:
  static bool Accept(Callbacks* impl,
                     mojo::internal::SerializationContext* context,
                     mojo::Message* message);
  static bool AcceptWithResponder(Callbacks* impl,
                                  mojo::internal::SerializationContext* context,
                                  mojo::Message* message,
                                  mojo::MessageReceiverWithStatus* responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Callbacks>>
class CallbacksStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  CallbacksStub() {}
  ~CallbacksStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  mojo::internal::SerializationContext* serialization_context() {
    return &serialization_context_;
  }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CallbacksStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      mojo::MessageReceiverWithStatus* responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CallbacksStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message,
        responder);
  }

 private:
  ImplPointerType sink_;
  mojo::internal::SerializationContext serialization_context_;
};
class CONTENT_EXPORT DatabaseCallbacksStubDispatch {
 public:
  static bool Accept(DatabaseCallbacks* impl,
                     mojo::internal::SerializationContext* context,
                     mojo::Message* message);
  static bool AcceptWithResponder(DatabaseCallbacks* impl,
                                  mojo::internal::SerializationContext* context,
                                  mojo::Message* message,
                                  mojo::MessageReceiverWithStatus* responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DatabaseCallbacks>>
class DatabaseCallbacksStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DatabaseCallbacksStub() {}
  ~DatabaseCallbacksStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  mojo::internal::SerializationContext* serialization_context() {
    return &serialization_context_;
  }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DatabaseCallbacksStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      mojo::MessageReceiverWithStatus* responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DatabaseCallbacksStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message,
        responder);
  }

 private:
  ImplPointerType sink_;
  mojo::internal::SerializationContext serialization_context_;
};
class CONTENT_EXPORT DatabaseStubDispatch {
 public:
  static bool Accept(Database* impl,
                     mojo::internal::SerializationContext* context,
                     mojo::Message* message);
  static bool AcceptWithResponder(Database* impl,
                                  mojo::internal::SerializationContext* context,
                                  mojo::Message* message,
                                  mojo::MessageReceiverWithStatus* responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Database>>
class DatabaseStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DatabaseStub() {}
  ~DatabaseStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  mojo::internal::SerializationContext* serialization_context() {
    return &serialization_context_;
  }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DatabaseStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      mojo::MessageReceiverWithStatus* responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DatabaseStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message,
        responder);
  }

 private:
  ImplPointerType sink_;
  mojo::internal::SerializationContext serialization_context_;
};
class CONTENT_EXPORT FactoryStubDispatch {
 public:
  static bool Accept(Factory* impl,
                     mojo::internal::SerializationContext* context,
                     mojo::Message* message);
  static bool AcceptWithResponder(Factory* impl,
                                  mojo::internal::SerializationContext* context,
                                  mojo::Message* message,
                                  mojo::MessageReceiverWithStatus* responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Factory>>
class FactoryStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FactoryStub() {}
  ~FactoryStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  mojo::internal::SerializationContext* serialization_context() {
    return &serialization_context_;
  }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FactoryStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      mojo::MessageReceiverWithStatus* responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FactoryStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message,
        responder);
  }

 private:
  ImplPointerType sink_;
  mojo::internal::SerializationContext serialization_context_;
};
class CONTENT_EXPORT CallbacksRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT DatabaseCallbacksRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT DatabaseRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT FactoryRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};


















class CONTENT_EXPORT IndexMetadata {
 public:
  using DataView = IndexMetadataDataView;
  using Data_ = internal::IndexMetadata_Data;

  static IndexMetadataPtr New();

  template <typename U>
  static IndexMetadataPtr From(const U& u) {
    return mojo::TypeConverter<IndexMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IndexMetadata>::Convert(*this);
  }

  IndexMetadata();
  ~IndexMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IndexMetadataPtr>
  IndexMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, IndexMetadata>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        IndexMetadata::DataView, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const mojo::Array<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        IndexMetadata::DataView, mojo::Array<uint8_t>>(
            input, output);
  }

  int64_t id;
  base::string16 name;
  content::IndexedDBKeyPath key_path;
  bool unique;
  bool multi_entry;
};



class CONTENT_EXPORT ObjectStoreMetadata {
 public:
  using DataView = ObjectStoreMetadataDataView;
  using Data_ = internal::ObjectStoreMetadata_Data;

  static ObjectStoreMetadataPtr New();

  template <typename U>
  static ObjectStoreMetadataPtr From(const U& u) {
    return mojo::TypeConverter<ObjectStoreMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ObjectStoreMetadata>::Convert(*this);
  }

  ObjectStoreMetadata();
  ~ObjectStoreMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ObjectStoreMetadataPtr>
  ObjectStoreMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ObjectStoreMetadata>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        ObjectStoreMetadata::DataView, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const mojo::Array<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        ObjectStoreMetadata::DataView, mojo::Array<uint8_t>>(
            input, output);
  }

  int64_t id;
  base::string16 name;
  content::IndexedDBKeyPath key_path;
  bool auto_increment;
  int64_t max_index_id;
  std::vector<content::IndexedDBIndexMetadata> indexes;
};



class CONTENT_EXPORT DatabaseMetadata {
 public:
  using DataView = DatabaseMetadataDataView;
  using Data_ = internal::DatabaseMetadata_Data;

  static DatabaseMetadataPtr New();

  template <typename U>
  static DatabaseMetadataPtr From(const U& u) {
    return mojo::TypeConverter<DatabaseMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DatabaseMetadata>::Convert(*this);
  }

  DatabaseMetadata();
  ~DatabaseMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DatabaseMetadataPtr>
  DatabaseMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, DatabaseMetadata>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        DatabaseMetadata::DataView, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const mojo::Array<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        DatabaseMetadata::DataView, mojo::Array<uint8_t>>(
            input, output);
  }

  int64_t id;
  base::string16 name;
  int64_t version;
  int64_t max_object_store_id;
  std::vector<content::IndexedDBObjectStoreMetadata> object_stores;
};



class CONTENT_EXPORT IndexKeys {
 public:
  using DataView = IndexKeysDataView;
  using Data_ = internal::IndexKeys_Data;

  static IndexKeysPtr New();

  template <typename U>
  static IndexKeysPtr From(const U& u) {
    return mojo::TypeConverter<IndexKeysPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IndexKeys>::Convert(*this);
  }

  IndexKeys();
  ~IndexKeys();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IndexKeysPtr>
  IndexKeysPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, IndexKeys>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        IndexKeys::DataView, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const mojo::Array<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        IndexKeys::DataView, mojo::Array<uint8_t>>(
            input, output);
  }

  int64_t index_id;
  std::vector<content::IndexedDBKey> index_keys;
};



class CONTENT_EXPORT FileInfo {
 public:
  using DataView = FileInfoDataView;
  using Data_ = internal::FileInfo_Data;

  static FileInfoPtr New();

  template <typename U>
  static FileInfoPtr From(const U& u) {
    return mojo::TypeConverter<FileInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FileInfo>::Convert(*this);
  }

  FileInfo();
  ~FileInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FileInfoPtr>
  FileInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, FileInfo>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        FileInfo::DataView, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const mojo::Array<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        FileInfo::DataView, mojo::Array<uint8_t>>(
            input, output);
  }

  base::FilePath path;
  base::string16 name;
  base::Time last_modified;
};



class CONTENT_EXPORT BlobInfo {
 public:
  using DataView = BlobInfoDataView;
  using Data_ = internal::BlobInfo_Data;

  static BlobInfoPtr New();

  template <typename U>
  static BlobInfoPtr From(const U& u) {
    return mojo::TypeConverter<BlobInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BlobInfo>::Convert(*this);
  }

  BlobInfo();
  ~BlobInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BlobInfoPtr>
  BlobInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, BlobInfo>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        BlobInfo::DataView, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const mojo::Array<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        BlobInfo::DataView, mojo::Array<uint8_t>>(
            input, output);
  }

  std::string uuid;
  base::string16 mime_type;
  uint64_t size;
  FileInfoPtr file;
 private:
  DISALLOW_COPY_AND_ASSIGN(BlobInfo);
};



class CONTENT_EXPORT Value {
 public:
  using DataView = ValueDataView;
  using Data_ = internal::Value_Data;

  static ValuePtr New();

  template <typename U>
  static ValuePtr From(const U& u) {
    return mojo::TypeConverter<ValuePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Value>::Convert(*this);
  }

  Value();
  ~Value();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ValuePtr>
  ValuePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, Value>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        Value::DataView, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const mojo::Array<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        Value::DataView, mojo::Array<uint8_t>>(
            input, output);
  }

  std::string bits;
  std::vector<BlobInfoPtr> blob_or_file_info;
 private:
  DISALLOW_COPY_AND_ASSIGN(Value);
};



class CONTENT_EXPORT ReturnValue {
 public:
  using DataView = ReturnValueDataView;
  using Data_ = internal::ReturnValue_Data;

  static ReturnValuePtr New();

  template <typename U>
  static ReturnValuePtr From(const U& u) {
    return mojo::TypeConverter<ReturnValuePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ReturnValue>::Convert(*this);
  }

  ReturnValue();
  ~ReturnValue();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ReturnValuePtr>
  ReturnValuePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ReturnValue>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        ReturnValue::DataView, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const mojo::Array<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        ReturnValue::DataView, mojo::Array<uint8_t>>(
            input, output);
  }

  ValuePtr value;
  content::IndexedDBKey primary_key;
  content::IndexedDBKeyPath key_path;
 private:
  DISALLOW_COPY_AND_ASSIGN(ReturnValue);
};


template <typename StructPtrType>
IndexMetadataPtr IndexMetadata::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->id = mojo::internal::Clone(id);
  rv->name = mojo::internal::Clone(name);
  rv->key_path = mojo::internal::Clone(key_path);
  rv->unique = mojo::internal::Clone(unique);
  rv->multi_entry = mojo::internal::Clone(multi_entry);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, IndexMetadata>::value>::type*>
bool IndexMetadata::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->id, other.id))
    return false;
  if (!mojo::internal::Equals(this->name, other.name))
    return false;
  if (!mojo::internal::Equals(this->key_path, other.key_path))
    return false;
  if (!mojo::internal::Equals(this->unique, other.unique))
    return false;
  if (!mojo::internal::Equals(this->multi_entry, other.multi_entry))
    return false;
  return true;
}
template <typename StructPtrType>
ObjectStoreMetadataPtr ObjectStoreMetadata::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->id = mojo::internal::Clone(id);
  rv->name = mojo::internal::Clone(name);
  rv->key_path = mojo::internal::Clone(key_path);
  rv->auto_increment = mojo::internal::Clone(auto_increment);
  rv->max_index_id = mojo::internal::Clone(max_index_id);
  rv->indexes = mojo::internal::Clone(indexes);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ObjectStoreMetadata>::value>::type*>
bool ObjectStoreMetadata::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->id, other.id))
    return false;
  if (!mojo::internal::Equals(this->name, other.name))
    return false;
  if (!mojo::internal::Equals(this->key_path, other.key_path))
    return false;
  if (!mojo::internal::Equals(this->auto_increment, other.auto_increment))
    return false;
  if (!mojo::internal::Equals(this->max_index_id, other.max_index_id))
    return false;
  if (!mojo::internal::Equals(this->indexes, other.indexes))
    return false;
  return true;
}
template <typename StructPtrType>
DatabaseMetadataPtr DatabaseMetadata::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->id = mojo::internal::Clone(id);
  rv->name = mojo::internal::Clone(name);
  rv->version = mojo::internal::Clone(version);
  rv->max_object_store_id = mojo::internal::Clone(max_object_store_id);
  rv->object_stores = mojo::internal::Clone(object_stores);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, DatabaseMetadata>::value>::type*>
bool DatabaseMetadata::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->id, other.id))
    return false;
  if (!mojo::internal::Equals(this->name, other.name))
    return false;
  if (!mojo::internal::Equals(this->version, other.version))
    return false;
  if (!mojo::internal::Equals(this->max_object_store_id, other.max_object_store_id))
    return false;
  if (!mojo::internal::Equals(this->object_stores, other.object_stores))
    return false;
  return true;
}
template <typename StructPtrType>
IndexKeysPtr IndexKeys::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->index_id = mojo::internal::Clone(index_id);
  rv->index_keys = mojo::internal::Clone(index_keys);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, IndexKeys>::value>::type*>
bool IndexKeys::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->index_id, other.index_id))
    return false;
  if (!mojo::internal::Equals(this->index_keys, other.index_keys))
    return false;
  return true;
}
template <typename StructPtrType>
FileInfoPtr FileInfo::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->path = mojo::internal::Clone(path);
  rv->name = mojo::internal::Clone(name);
  rv->last_modified = mojo::internal::Clone(last_modified);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, FileInfo>::value>::type*>
bool FileInfo::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->path, other.path))
    return false;
  if (!mojo::internal::Equals(this->name, other.name))
    return false;
  if (!mojo::internal::Equals(this->last_modified, other.last_modified))
    return false;
  return true;
}
template <typename StructPtrType>
BlobInfoPtr BlobInfo::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->uuid = mojo::internal::Clone(uuid);
  rv->mime_type = mojo::internal::Clone(mime_type);
  rv->size = mojo::internal::Clone(size);
  rv->file = mojo::internal::Clone(file);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, BlobInfo>::value>::type*>
bool BlobInfo::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->uuid, other.uuid))
    return false;
  if (!mojo::internal::Equals(this->mime_type, other.mime_type))
    return false;
  if (!mojo::internal::Equals(this->size, other.size))
    return false;
  if (!mojo::internal::Equals(this->file, other.file))
    return false;
  return true;
}
template <typename StructPtrType>
ValuePtr Value::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->bits = mojo::internal::Clone(bits);
  rv->blob_or_file_info = mojo::internal::Clone(blob_or_file_info);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, Value>::value>::type*>
bool Value::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->bits, other.bits))
    return false;
  if (!mojo::internal::Equals(this->blob_or_file_info, other.blob_or_file_info))
    return false;
  return true;
}
template <typename StructPtrType>
ReturnValuePtr ReturnValue::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->value = mojo::internal::Clone(value);
  rv->primary_key = mojo::internal::Clone(primary_key);
  rv->key_path = mojo::internal::Clone(key_path);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ReturnValue>::value>::type*>
bool ReturnValue::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->value, other.value))
    return false;
  if (!mojo::internal::Equals(this->primary_key, other.primary_key))
    return false;
  if (!mojo::internal::Equals(this->key_path, other.key_path))
    return false;
  return true;
}


}  // namespace mojom
}  // namespace indexed_db

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::indexed_db::mojom::IndexMetadata::DataView,
                                         ::indexed_db::mojom::IndexMetadataPtr> {
  static bool IsNull(const ::indexed_db::mojom::IndexMetadataPtr& input) { return !input; }
  static void SetToNull(::indexed_db::mojom::IndexMetadataPtr* output) { output->reset(); }

  static decltype(::indexed_db::mojom::IndexMetadata::id) id(
      const ::indexed_db::mojom::IndexMetadataPtr& input) {
    return input->id;
  }

  static const decltype(::indexed_db::mojom::IndexMetadata::name)& name(
      const ::indexed_db::mojom::IndexMetadataPtr& input) {
    return input->name;
  }

  static const decltype(::indexed_db::mojom::IndexMetadata::key_path)& key_path(
      const ::indexed_db::mojom::IndexMetadataPtr& input) {
    return input->key_path;
  }

  static decltype(::indexed_db::mojom::IndexMetadata::unique) unique(
      const ::indexed_db::mojom::IndexMetadataPtr& input) {
    return input->unique;
  }

  static decltype(::indexed_db::mojom::IndexMetadata::multi_entry) multi_entry(
      const ::indexed_db::mojom::IndexMetadataPtr& input) {
    return input->multi_entry;
  }

  static bool Read(::indexed_db::mojom::IndexMetadata::DataView input, ::indexed_db::mojom::IndexMetadataPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::indexed_db::mojom::ObjectStoreMetadata::DataView,
                                         ::indexed_db::mojom::ObjectStoreMetadataPtr> {
  static bool IsNull(const ::indexed_db::mojom::ObjectStoreMetadataPtr& input) { return !input; }
  static void SetToNull(::indexed_db::mojom::ObjectStoreMetadataPtr* output) { output->reset(); }

  static decltype(::indexed_db::mojom::ObjectStoreMetadata::id) id(
      const ::indexed_db::mojom::ObjectStoreMetadataPtr& input) {
    return input->id;
  }

  static const decltype(::indexed_db::mojom::ObjectStoreMetadata::name)& name(
      const ::indexed_db::mojom::ObjectStoreMetadataPtr& input) {
    return input->name;
  }

  static const decltype(::indexed_db::mojom::ObjectStoreMetadata::key_path)& key_path(
      const ::indexed_db::mojom::ObjectStoreMetadataPtr& input) {
    return input->key_path;
  }

  static decltype(::indexed_db::mojom::ObjectStoreMetadata::auto_increment) auto_increment(
      const ::indexed_db::mojom::ObjectStoreMetadataPtr& input) {
    return input->auto_increment;
  }

  static decltype(::indexed_db::mojom::ObjectStoreMetadata::max_index_id) max_index_id(
      const ::indexed_db::mojom::ObjectStoreMetadataPtr& input) {
    return input->max_index_id;
  }

  static const decltype(::indexed_db::mojom::ObjectStoreMetadata::indexes)& indexes(
      const ::indexed_db::mojom::ObjectStoreMetadataPtr& input) {
    return input->indexes;
  }

  static bool Read(::indexed_db::mojom::ObjectStoreMetadata::DataView input, ::indexed_db::mojom::ObjectStoreMetadataPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::indexed_db::mojom::DatabaseMetadata::DataView,
                                         ::indexed_db::mojom::DatabaseMetadataPtr> {
  static bool IsNull(const ::indexed_db::mojom::DatabaseMetadataPtr& input) { return !input; }
  static void SetToNull(::indexed_db::mojom::DatabaseMetadataPtr* output) { output->reset(); }

  static decltype(::indexed_db::mojom::DatabaseMetadata::id) id(
      const ::indexed_db::mojom::DatabaseMetadataPtr& input) {
    return input->id;
  }

  static const decltype(::indexed_db::mojom::DatabaseMetadata::name)& name(
      const ::indexed_db::mojom::DatabaseMetadataPtr& input) {
    return input->name;
  }

  static decltype(::indexed_db::mojom::DatabaseMetadata::version) version(
      const ::indexed_db::mojom::DatabaseMetadataPtr& input) {
    return input->version;
  }

  static decltype(::indexed_db::mojom::DatabaseMetadata::max_object_store_id) max_object_store_id(
      const ::indexed_db::mojom::DatabaseMetadataPtr& input) {
    return input->max_object_store_id;
  }

  static const decltype(::indexed_db::mojom::DatabaseMetadata::object_stores)& object_stores(
      const ::indexed_db::mojom::DatabaseMetadataPtr& input) {
    return input->object_stores;
  }

  static bool Read(::indexed_db::mojom::DatabaseMetadata::DataView input, ::indexed_db::mojom::DatabaseMetadataPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::indexed_db::mojom::IndexKeys::DataView,
                                         ::indexed_db::mojom::IndexKeysPtr> {
  static bool IsNull(const ::indexed_db::mojom::IndexKeysPtr& input) { return !input; }
  static void SetToNull(::indexed_db::mojom::IndexKeysPtr* output) { output->reset(); }

  static decltype(::indexed_db::mojom::IndexKeys::index_id) index_id(
      const ::indexed_db::mojom::IndexKeysPtr& input) {
    return input->index_id;
  }

  static const decltype(::indexed_db::mojom::IndexKeys::index_keys)& index_keys(
      const ::indexed_db::mojom::IndexKeysPtr& input) {
    return input->index_keys;
  }

  static bool Read(::indexed_db::mojom::IndexKeys::DataView input, ::indexed_db::mojom::IndexKeysPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::indexed_db::mojom::FileInfo::DataView,
                                         ::indexed_db::mojom::FileInfoPtr> {
  static bool IsNull(const ::indexed_db::mojom::FileInfoPtr& input) { return !input; }
  static void SetToNull(::indexed_db::mojom::FileInfoPtr* output) { output->reset(); }

  static const decltype(::indexed_db::mojom::FileInfo::path)& path(
      const ::indexed_db::mojom::FileInfoPtr& input) {
    return input->path;
  }

  static const decltype(::indexed_db::mojom::FileInfo::name)& name(
      const ::indexed_db::mojom::FileInfoPtr& input) {
    return input->name;
  }

  static const decltype(::indexed_db::mojom::FileInfo::last_modified)& last_modified(
      const ::indexed_db::mojom::FileInfoPtr& input) {
    return input->last_modified;
  }

  static bool Read(::indexed_db::mojom::FileInfo::DataView input, ::indexed_db::mojom::FileInfoPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::indexed_db::mojom::BlobInfo::DataView,
                                         ::indexed_db::mojom::BlobInfoPtr> {
  static bool IsNull(const ::indexed_db::mojom::BlobInfoPtr& input) { return !input; }
  static void SetToNull(::indexed_db::mojom::BlobInfoPtr* output) { output->reset(); }

  static const decltype(::indexed_db::mojom::BlobInfo::uuid)& uuid(
      const ::indexed_db::mojom::BlobInfoPtr& input) {
    return input->uuid;
  }

  static const decltype(::indexed_db::mojom::BlobInfo::mime_type)& mime_type(
      const ::indexed_db::mojom::BlobInfoPtr& input) {
    return input->mime_type;
  }

  static decltype(::indexed_db::mojom::BlobInfo::size) size(
      const ::indexed_db::mojom::BlobInfoPtr& input) {
    return input->size;
  }

  static const decltype(::indexed_db::mojom::BlobInfo::file)& file(
      const ::indexed_db::mojom::BlobInfoPtr& input) {
    return input->file;
  }

  static bool Read(::indexed_db::mojom::BlobInfo::DataView input, ::indexed_db::mojom::BlobInfoPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::indexed_db::mojom::Value::DataView,
                                         ::indexed_db::mojom::ValuePtr> {
  static bool IsNull(const ::indexed_db::mojom::ValuePtr& input) { return !input; }
  static void SetToNull(::indexed_db::mojom::ValuePtr* output) { output->reset(); }

  static const decltype(::indexed_db::mojom::Value::bits)& bits(
      const ::indexed_db::mojom::ValuePtr& input) {
    return input->bits;
  }

  static const decltype(::indexed_db::mojom::Value::blob_or_file_info)& blob_or_file_info(
      const ::indexed_db::mojom::ValuePtr& input) {
    return input->blob_or_file_info;
  }

  static bool Read(::indexed_db::mojom::Value::DataView input, ::indexed_db::mojom::ValuePtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::indexed_db::mojom::ReturnValue::DataView,
                                         ::indexed_db::mojom::ReturnValuePtr> {
  static bool IsNull(const ::indexed_db::mojom::ReturnValuePtr& input) { return !input; }
  static void SetToNull(::indexed_db::mojom::ReturnValuePtr* output) { output->reset(); }

  static const decltype(::indexed_db::mojom::ReturnValue::value)& value(
      const ::indexed_db::mojom::ReturnValuePtr& input) {
    return input->value;
  }

  static const decltype(::indexed_db::mojom::ReturnValue::primary_key)& primary_key(
      const ::indexed_db::mojom::ReturnValuePtr& input) {
    return input->primary_key;
  }

  static const decltype(::indexed_db::mojom::ReturnValue::key_path)& key_path(
      const ::indexed_db::mojom::ReturnValuePtr& input) {
    return input->key_path;
  }

  static bool Read(::indexed_db::mojom::ReturnValue::DataView input, ::indexed_db::mojom::ReturnValuePtr* output);
};

}  // namespace mojo

#endif  // CONTENT_COMMON_INDEXED_DB_INDEXED_DB_MOJOM_H_