// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_H_
#define CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_H_

#include <stdint.h>

#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/lib/union_accessor.h"
#include "mojo/public/cpp/bindings/map.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/no_interface.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/common/render_frame_message_filter.mojom-shared.h"
#include "url/mojo/url.mojom.h"
#include "mojo/public/cpp/bindings/array.h"
#include "mojo/public/cpp/bindings/string.h"
#include "gpu/config/dx_diag_node.h"
#include "ui/gfx/geometry/point_f.h"
#include "ui/gfx/geometry/vector2d_f.h"
#include "content/common/indexed_db/indexed_db_key_range.h"
#include "ui/gfx/geometry/insets.h"
#include "gpu/command_buffer/common/capabilities.h"
#include "media/base/demuxer_stream.h"
#include "content/common/indexed_db/indexed_db_key.h"
#include "base/values.h"
#include "cc/output/compositor_frame_metadata.h"
#include "media/base/audio_codecs.h"
#include "ui/gfx/geometry/rect_f.h"
#include "content/common/resize_params.h"
#include "media/base/cdm_promise.h"
#include "content/common/indexed_db/indexed_db_metadata.h"
#include "media/base/buffering_state.h"
#include "url/origin.h"
#include "cc/output/compositor_frame.h"
#include "base/unguessable_token.h"
#include "third_party/WebKit/public/platform/WebReferrerPolicy.h"
#include "ui/gfx/geometry/safe_integer_conversions.h"
#include "ui/base/window_open_disposition.h"
#include "cc/quads/shared_quad_state.h"
#include "gpu/ipc/common/surface_handle.h"
#include "net/url_request/redirect_info.h"
#include "content/common/service_worker/service_worker_status_code.h"
#include "gpu/command_buffer/common/sync_token.h"
#include "cc/output/filter_operations.h"
#include "media/capture/video_capture_types.h"
#include "gpu/config/gpu_info.h"
#include "cc/quads/render_pass_id.h"
#include "ui/gfx/gpu_memory_buffer.h"
#include "ui/events/event.h"
#include "media/base/sample_format.h"
#include "media/base/eme_constants.h"
#include "media/base/video_codecs.h"
#include "third_party/WebKit/public/platform/modules/indexeddb/WebIDBTypes.h"
#include "media/base/encryption_scheme.h"
#include "cc/output/begin_frame_args.h"
#include "third_party/WebKit/public/web/WebPopupType.h"
#include "media/base/cdm_key_information.h"
#include "cc/quads/draw_quad.h"
#include "media/base/audio_parameters.h"
#include "cc/resources/returned_resource.h"
#include "content/common/frame_owner_properties.h"
#include "gpu/command_buffer/common/mailbox.h"
#include "media/base/pipeline_status.h"
#include "services/service_manager/public/cpp/service_info.h"
#include "url/gurl.h"
#include "cc/resources/transferable_resource.h"
#include "cc/surfaces/local_frame_id.h"
#include "media/capture/video/video_capture_device_descriptor.h"
#include "cc/surfaces/surface_sequence.h"
#include "content/public/common/renderer_preferences.h"
#include "media/base/decryptor.h"
#include "cc/output/filter_operation.h"
#include "ui/gfx/icc_profile.h"
#include "third_party/WebKit/public/web/WebWindowFeatures.h"
#include "content/public/common/media_metadata.h"
#include "services/service_manager/public/cpp/identity.h"
#include "content/common/bluetooth/web_bluetooth_device_id.h"
#include "ui/gfx/geometry/size.h"
#include "cc/input/selection.h"
#include "content/public/common/referrer.h"
#include "ui/events/latency_info.h"
#include "content/public/common/web_preferences.h"
#include "cc/quads/render_pass.h"
#include "ui/gfx/native_pixmap_handle.h"
#include "media/base/subsample_entry.h"
#include "content/common/media/media_devices.h"
#include "cc/surfaces/frame_sink_id.h"
#include "ui/gfx/transform.h"
#include "device/bluetooth/bluetooth_uuid.h"
#include "content/common/resource_request_completion_status.h"
#include "ui/gfx/geometry/rect.h"
#include "cc/surfaces/surface_id.h"
#include "media/base/channel_layout.h"
#include "ui/gfx/geometry/vector2d.h"
#include "services/video_capture/public/cpp/capture_settings.h"
#include "services/service_manager/public/cpp/interface_provider_spec.h"
#include "content/common/service_worker/embedded_worker_start_params.h"
#include "third_party/skia/include/core/SkImageFilter.h"
#include "media/base/media_keys.h"
#include "ui/display/display.h"
#include "base/version.h"
#include "base/time/time.h"
#include "base/strings/string16.h"
#include "ui/gfx/selection_bound.h"
#include "ui/gfx/geometry/point.h"
#include "content/public/common/resource_response.h"
#include "base/files/file_path.h"
#include "gpu/command_buffer/common/mailbox_holder.h"
#include "net/base/network_change_notifier.h"
#include "ui/gfx/buffer_types.h"
#include "content/common/indexed_db/indexed_db_key_path.h"
#include "third_party/skia/include/core/SkBitmap.h"
#include "content/common/frame_replication_state.h"
#include "ui/gfx/native_widget_types.h"
#include "media/base/decode_status.h"
#include "content/common/resource_request.h"
#include "content/common/service_worker/service_worker_types.h"
#include "media/base/video_types.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {
class RenderFrameMessageFilter;
using RenderFrameMessageFilterPtr = mojo::InterfacePtr<RenderFrameMessageFilter>;
using RenderFrameMessageFilterPtrInfo = mojo::InterfacePtrInfo<RenderFrameMessageFilter>;
using ThreadSafeRenderFrameMessageFilterPtr =
    mojo::ThreadSafeInterfacePtr<RenderFrameMessageFilter>;
using RenderFrameMessageFilterRequest = mojo::InterfaceRequest<RenderFrameMessageFilter>;
using RenderFrameMessageFilterAssociatedPtr =
    mojo::AssociatedInterfacePtr<RenderFrameMessageFilter>;
using ThreadSafeRenderFrameMessageFilterAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<RenderFrameMessageFilter>;
using RenderFrameMessageFilterAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<RenderFrameMessageFilter>;
using RenderFrameMessageFilterAssociatedRequest =
    mojo::AssociatedInterfaceRequest<RenderFrameMessageFilter>;


class RenderFrameMessageFilterProxy;

template <typename ImplRefTraits>
class RenderFrameMessageFilterStub;

class RenderFrameMessageFilterRequestValidator;
class RenderFrameMessageFilterResponseValidator;

class CONTENT_EXPORT RenderFrameMessageFilter
    : public RenderFrameMessageFilterInterfaceBase {
 public:
  static const char Name_[];
  static const uint32_t Version_ = 0;
  static const bool PassesAssociatedKinds_ = false;
  static const bool HasSyncMethods_ = true;

  using Proxy_ = RenderFrameMessageFilterProxy;

  template <typename ImplRefTraits>
  using Stub_ = RenderFrameMessageFilterStub<ImplRefTraits>;

  using RequestValidator_ = RenderFrameMessageFilterRequestValidator;
  using ResponseValidator_ = RenderFrameMessageFilterResponseValidator;
  virtual ~RenderFrameMessageFilter() {}

  virtual void SetCookie(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, const std::string& cookie) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  virtual bool GetCookies(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, std::string* cookies);

  using GetCookiesCallback = base::Callback<void(const std::string&)>;
  virtual void GetCookies(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, const GetCookiesCallback& callback) = 0;
};

class CONTENT_EXPORT RenderFrameMessageFilterProxy
    : public RenderFrameMessageFilter {
 public:
  explicit RenderFrameMessageFilterProxy(mojo::MessageReceiverWithResponder* receiver);
  void SetCookie(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, const std::string& cookie) override;
  bool GetCookies(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, std::string* cookies) override;
  void GetCookies(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, const GetCookiesCallback& callback) override;

  void set_group_controller(
        scoped_refptr<mojo::AssociatedGroupController> group_controller) {
    group_controller_ = std::move(group_controller);
  }
 private:
  mojo::MessageReceiverWithResponder* receiver_;
  scoped_refptr<mojo::AssociatedGroupController> group_controller_;
};
class CONTENT_EXPORT RenderFrameMessageFilterStubDispatch {
 public:
  static bool Accept(RenderFrameMessageFilter* impl,
                     mojo::internal::SerializationContext* context,
                     mojo::Message* message);
  static bool AcceptWithResponder(RenderFrameMessageFilter* impl,
                                  mojo::internal::SerializationContext* context,
                                  mojo::Message* message,
                                  mojo::MessageReceiverWithStatus* responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<RenderFrameMessageFilter>>
class RenderFrameMessageFilterStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  RenderFrameMessageFilterStub() {}
  ~RenderFrameMessageFilterStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  mojo::internal::SerializationContext* serialization_context() {
    return &serialization_context_;
  }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RenderFrameMessageFilterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      mojo::MessageReceiverWithStatus* responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RenderFrameMessageFilterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message,
        responder);
  }

 private:
  ImplPointerType sink_;
  mojo::internal::SerializationContext serialization_context_;
};
class CONTENT_EXPORT RenderFrameMessageFilterRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT RenderFrameMessageFilterResponseValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#endif  // CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_H_