// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_SERVICE_WORKER_EMBEDDED_WORKER_SETUP_MOJOM_SHARED_H_
#define CONTENT_COMMON_SERVICE_WORKER_EMBEDDED_WORKER_SETUP_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "content/common/service_worker/embedded_worker_setup.mojom-shared-internal.h"
#include "services/service_manager/public/interfaces/interface_provider.mojom-shared.h"


namespace content {
namespace mojom {


}  // namespace mojom
}  // namespace content

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace content {
namespace mojom {
// Interface base classes. They are used for type safety check.
class EmbeddedWorkerSetupInterfaceBase {};

using EmbeddedWorkerSetupPtrDataView =
    mojo::InterfacePtrDataView<EmbeddedWorkerSetupInterfaceBase>;
using EmbeddedWorkerSetupRequestDataView =
    mojo::InterfaceRequestDataView<EmbeddedWorkerSetupInterfaceBase>;
using EmbeddedWorkerSetupAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<EmbeddedWorkerSetupInterfaceBase>;
using EmbeddedWorkerSetupAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<EmbeddedWorkerSetupInterfaceBase>;
class EmbeddedWorkerSetup_ExchangeInterfaceProviders_ParamsDataView {
 public:
  EmbeddedWorkerSetup_ExchangeInterfaceProviders_ParamsDataView() {}

  EmbeddedWorkerSetup_ExchangeInterfaceProviders_ParamsDataView(
      internal::EmbeddedWorkerSetup_ExchangeInterfaceProviders_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t thread_id() const {
    return data_->thread_id;
  }
  template <typename UserType>
  UserType TakeRemoteInterfaces() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::service_manager::mojom::InterfaceProviderRequestDataView>(
            &data_->remote_interfaces, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeLocalInterfaces() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::service_manager::mojom::InterfaceProviderPtrDataView>(
            &data_->local_interfaces, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::EmbeddedWorkerSetup_ExchangeInterfaceProviders_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace content

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace content {
namespace mojom {




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_SERVICE_WORKER_EMBEDDED_WORKER_SETUP_MOJOM_SHARED_H_
