// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_SERVICE_WORKER_FETCH_EVENT_DISPATCHER_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_SERVICE_WORKER_FETCH_EVENT_DISPATCHER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "content/common/url_loader.mojom-shared-internal.h"
#include "mojo/common/common_custom_types.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/serviceworker/service_worker_event_status.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {
using ServiceWorkerFetchRequest_Data = mojo::internal::NativeStruct_Data;
class FetchEventPreloadHandle_Data;

#pragma pack(push, 1)
class FetchEventPreloadHandle_Data {
 public:
  static FetchEventPreloadHandle_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(FetchEventPreloadHandle_Data))) FetchEventPreloadHandle_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data url_loader;
  mojo::internal::Handle_Data url_loader_client_request;
  uint8_t padfinal_[4];

 private:
  FetchEventPreloadHandle_Data() : header_({sizeof(*this), 0}) {
  }
  ~FetchEventPreloadHandle_Data() = delete;
};
static_assert(sizeof(FetchEventPreloadHandle_Data) == 24,
              "Bad sizeof(FetchEventPreloadHandle_Data)");
const uint32_t kFetchEventDispatcher_DispatchFetchEvent_Name = 0;
class FetchEventDispatcher_DispatchFetchEvent_Params_Data {
 public:
  static FetchEventDispatcher_DispatchFetchEvent_Params_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(FetchEventDispatcher_DispatchFetchEvent_Params_Data))) FetchEventDispatcher_DispatchFetchEvent_Params_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t fetch_event_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<internal::ServiceWorkerFetchRequest_Data> request;
  mojo::internal::Pointer<internal::FetchEventPreloadHandle_Data> preload_handle;

 private:
  FetchEventDispatcher_DispatchFetchEvent_Params_Data() : header_({sizeof(*this), 0}) {
  }
  ~FetchEventDispatcher_DispatchFetchEvent_Params_Data() = delete;
};
static_assert(sizeof(FetchEventDispatcher_DispatchFetchEvent_Params_Data) == 32,
              "Bad sizeof(FetchEventDispatcher_DispatchFetchEvent_Params_Data)");
class FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data {
 public:
  static FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data))) FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data() : header_({sizeof(*this), 0}) {
  }
  ~FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data) == 24,
              "Bad sizeof(FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_SERVICE_WORKER_FETCH_EVENT_DISPATCHER_MOJOM_SHARED_INTERNAL_H_