// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "device/serial/serial.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace device {
namespace serial {// static
DeviceInfoPtr DeviceInfo::New() {
  DeviceInfoPtr rv;
  mojo::internal::StructHelper<DeviceInfo>::Initialize(&rv);
  return rv;
}

DeviceInfo::DeviceInfo()
    : path(),
      vendor_id(),
      has_vendor_id(false),
      product_id(),
      has_product_id(false),
      display_name() {
}

DeviceInfo::~DeviceInfo() {
}// static
ConnectionOptionsPtr ConnectionOptions::New() {
  ConnectionOptionsPtr rv;
  mojo::internal::StructHelper<ConnectionOptions>::Initialize(&rv);
  return rv;
}

ConnectionOptions::ConnectionOptions()
    : bitrate(0U),
      data_bits(DataBits::NONE),
      parity_bit(ParityBit::NONE),
      stop_bits(StopBits::NONE),
      cts_flow_control(),
      has_cts_flow_control(false) {
}

ConnectionOptions::~ConnectionOptions() {
}
size_t ConnectionOptions::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->bitrate);
  seed = mojo::internal::Hash(seed, this->data_bits);
  seed = mojo::internal::Hash(seed, this->parity_bit);
  seed = mojo::internal::Hash(seed, this->stop_bits);
  seed = mojo::internal::Hash(seed, this->cts_flow_control);
  seed = mojo::internal::Hash(seed, this->has_cts_flow_control);
  return seed;
}// static
ConnectionInfoPtr ConnectionInfo::New() {
  ConnectionInfoPtr rv;
  mojo::internal::StructHelper<ConnectionInfo>::Initialize(&rv);
  return rv;
}

ConnectionInfo::ConnectionInfo()
    : bitrate(0U),
      data_bits(DataBits::NONE),
      parity_bit(ParityBit::NONE),
      stop_bits(StopBits::NONE),
      cts_flow_control() {
}

ConnectionInfo::~ConnectionInfo() {
}
size_t ConnectionInfo::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->bitrate);
  seed = mojo::internal::Hash(seed, this->data_bits);
  seed = mojo::internal::Hash(seed, this->parity_bit);
  seed = mojo::internal::Hash(seed, this->stop_bits);
  seed = mojo::internal::Hash(seed, this->cts_flow_control);
  return seed;
}// static
HostControlSignalsPtr HostControlSignals::New() {
  HostControlSignalsPtr rv;
  mojo::internal::StructHelper<HostControlSignals>::Initialize(&rv);
  return rv;
}

HostControlSignals::HostControlSignals()
    : dtr(),
      has_dtr(false),
      rts(),
      has_rts(false) {
}

HostControlSignals::~HostControlSignals() {
}
size_t HostControlSignals::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->dtr);
  seed = mojo::internal::Hash(seed, this->has_dtr);
  seed = mojo::internal::Hash(seed, this->rts);
  seed = mojo::internal::Hash(seed, this->has_rts);
  return seed;
}// static
DeviceControlSignalsPtr DeviceControlSignals::New() {
  DeviceControlSignalsPtr rv;
  mojo::internal::StructHelper<DeviceControlSignals>::Initialize(&rv);
  return rv;
}

DeviceControlSignals::DeviceControlSignals()
    : dcd(),
      cts(),
      ri(),
      dsr() {
}

DeviceControlSignals::~DeviceControlSignals() {
}
size_t DeviceControlSignals::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->dcd);
  seed = mojo::internal::Hash(seed, this->cts);
  seed = mojo::internal::Hash(seed, this->ri);
  seed = mojo::internal::Hash(seed, this->dsr);
  return seed;
}
}  // namespace serial
}  // namespace device

namespace mojo {


// static
bool StructTraits<::device::serial::DeviceInfo::DataView, ::device::serial::DeviceInfoPtr>::Read(
    ::device::serial::DeviceInfo::DataView input,
    ::device::serial::DeviceInfoPtr* output) {
  bool success = true;
  ::device::serial::DeviceInfoPtr result(::device::serial::DeviceInfo::New());
  
      if (!input.ReadPath(&result->path))
        success = false;
      result->vendor_id = input.vendor_id();
      result->has_vendor_id = input.has_vendor_id();
      result->product_id = input.product_id();
      result->has_product_id = input.has_product_id();
      if (!input.ReadDisplayName(&result->display_name))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::device::serial::ConnectionOptions::DataView, ::device::serial::ConnectionOptionsPtr>::Read(
    ::device::serial::ConnectionOptions::DataView input,
    ::device::serial::ConnectionOptionsPtr* output) {
  bool success = true;
  ::device::serial::ConnectionOptionsPtr result(::device::serial::ConnectionOptions::New());
  
      result->bitrate = input.bitrate();
      if (!input.ReadDataBits(&result->data_bits))
        success = false;
      if (!input.ReadParityBit(&result->parity_bit))
        success = false;
      if (!input.ReadStopBits(&result->stop_bits))
        success = false;
      result->cts_flow_control = input.cts_flow_control();
      result->has_cts_flow_control = input.has_cts_flow_control();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::device::serial::ConnectionInfo::DataView, ::device::serial::ConnectionInfoPtr>::Read(
    ::device::serial::ConnectionInfo::DataView input,
    ::device::serial::ConnectionInfoPtr* output) {
  bool success = true;
  ::device::serial::ConnectionInfoPtr result(::device::serial::ConnectionInfo::New());
  
      result->bitrate = input.bitrate();
      if (!input.ReadDataBits(&result->data_bits))
        success = false;
      if (!input.ReadParityBit(&result->parity_bit))
        success = false;
      if (!input.ReadStopBits(&result->stop_bits))
        success = false;
      result->cts_flow_control = input.cts_flow_control();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::device::serial::HostControlSignals::DataView, ::device::serial::HostControlSignalsPtr>::Read(
    ::device::serial::HostControlSignals::DataView input,
    ::device::serial::HostControlSignalsPtr* output) {
  bool success = true;
  ::device::serial::HostControlSignalsPtr result(::device::serial::HostControlSignals::New());
  
      result->dtr = input.dtr();
      result->has_dtr = input.has_dtr();
      result->rts = input.rts();
      result->has_rts = input.has_rts();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::device::serial::DeviceControlSignals::DataView, ::device::serial::DeviceControlSignalsPtr>::Read(
    ::device::serial::DeviceControlSignals::DataView input,
    ::device::serial::DeviceControlSignalsPtr* output) {
  bool success = true;
  ::device::serial::DeviceControlSignalsPtr result(::device::serial::DeviceControlSignals::New());
  
      result->dcd = input.dcd();
      result->cts = input.cts();
      result->ri = input.ri();
      result->dsr = input.dsr();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif