// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_MOCK_DEVICE_MOJOM_SHARED_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_MOCK_DEVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/video_capture/public/interfaces/mock_device.mojom-shared-internal.h"


namespace video_capture {
namespace mojom {


}  // namespace mojom
}  // namespace video_capture

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace video_capture {
namespace mojom {
// Interface base classes. They are used for type safety check.
class MockDeviceClientInterfaceBase {};

using MockDeviceClientPtrDataView =
    mojo::InterfacePtrDataView<MockDeviceClientInterfaceBase>;
using MockDeviceClientRequestDataView =
    mojo::InterfaceRequestDataView<MockDeviceClientInterfaceBase>;
using MockDeviceClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MockDeviceClientInterfaceBase>;
using MockDeviceClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MockDeviceClientInterfaceBase>;
class MockMediaDeviceInterfaceBase {};

using MockMediaDevicePtrDataView =
    mojo::InterfacePtrDataView<MockMediaDeviceInterfaceBase>;
using MockMediaDeviceRequestDataView =
    mojo::InterfaceRequestDataView<MockMediaDeviceInterfaceBase>;
using MockMediaDeviceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MockMediaDeviceInterfaceBase>;
using MockMediaDeviceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MockMediaDeviceInterfaceBase>;
class MockMediaDevice_AllocateAndStart_ParamsDataView {
 public:
  MockMediaDevice_AllocateAndStart_ParamsDataView() {}

  MockMediaDevice_AllocateAndStart_ParamsDataView(
      internal::MockMediaDevice_AllocateAndStart_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::MockDeviceClientPtrDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::MockMediaDevice_AllocateAndStart_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MockMediaDevice_StopAndDeAllocate_ParamsDataView {
 public:
  MockMediaDevice_StopAndDeAllocate_ParamsDataView() {}

  MockMediaDevice_StopAndDeAllocate_ParamsDataView(
      internal::MockMediaDevice_StopAndDeAllocate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MockMediaDevice_StopAndDeAllocate_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace video_capture

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace video_capture {
namespace mojom {






}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_MOCK_DEVICE_MOJOM_SHARED_H_
