// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/video_capture/public/interfaces/mock_device.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "media/mojo/interfaces/pipeline_statistics_struct_traits.h"
#include "media/base/ipc/media_param_traits_macros.h"
#include "media/capture/ipc/capture_param_traits.h"
#include "media/capture/mojo/video_capture_types_typemap_traits.h"
#include "services/video_capture/public/interfaces/device_descriptor_struct_traits.h"
#include "mojo/common/common_custom_types_struct_traits.h"
#include "services/service_manager/public/cpp/service_info_struct_traits.h"
#include "media/capture/ipc/capture_param_traits_macros.h"
#include "services/service_manager/public/cpp/interface_provider_spec_struct_traits.h"
#include "ipc/ipc_message_utils.h"
#include "services/video_capture/public/interfaces/capture_settings_traits.h"
#include "media/base/ipc/media_param_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "url/mojo/url_gurl_struct_traits.h"
#include "services/service_manager/public/cpp/identity_struct_traits.h"
namespace video_capture {
namespace mojom {
const char MockDeviceClient::Name_[] = "video_capture::mojom::MockDeviceClient";
const uint32_t MockDeviceClient::Version_;

MockDeviceClientProxy::MockDeviceClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

// static
bool MockDeviceClientStubDispatch::Accept(
    MockDeviceClient* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message) {
  return false;
}

// static
bool MockDeviceClientStubDispatch::AcceptWithResponder(
    MockDeviceClient* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message,
    mojo::MessageReceiverWithStatus* responder) {
  return false;
}

bool MockDeviceClientRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "MockDeviceClient RequestValidator");

  switch (message->header()->name) {
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char MockMediaDevice::Name_[] = "video_capture::mojom::MockMediaDevice";
const uint32_t MockMediaDevice::Version_;

MockMediaDeviceProxy::MockMediaDeviceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void MockMediaDeviceProxy::AllocateAndStart(
    MockDeviceClientPtr in_client) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::video_capture::mojom::internal::MockMediaDevice_AllocateAndStart_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kMockMediaDevice_AllocateAndStart_Name, size);

  auto params =
      ::video_capture::mojom::internal::MockMediaDevice_AllocateAndStart_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::video_capture::mojom::MockDeviceClientPtrDataView>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in MockMediaDevice.AllocateAndStart request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}

void MockMediaDeviceProxy::StopAndDeAllocate(
    ) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::video_capture::mojom::internal::MockMediaDevice_StopAndDeAllocate_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kMockMediaDevice_StopAndDeAllocate_Name, size);

  auto params =
      ::video_capture::mojom::internal::MockMediaDevice_StopAndDeAllocate_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}

// static
bool MockMediaDeviceStubDispatch::Accept(
    MockMediaDevice* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kMockMediaDevice_AllocateAndStart_Name: {
      internal::MockMediaDevice_AllocateAndStart_Params_Data* params =
          reinterpret_cast<internal::MockMediaDevice_AllocateAndStart_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      MockDeviceClientPtr p_client{};
      MockMediaDevice_AllocateAndStart_ParamsDataView input_data_view(params,
                                              context);
      
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "MockMediaDevice::AllocateAndStart deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "MockMediaDevice::AllocateAndStart");
      mojo::internal::MessageDispatchContext context(message);
      impl->AllocateAndStart(
std::move(p_client));
      return true;
    }
    case internal::kMockMediaDevice_StopAndDeAllocate_Name: {
      internal::MockMediaDevice_StopAndDeAllocate_Params_Data* params =
          reinterpret_cast<internal::MockMediaDevice_StopAndDeAllocate_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      MockMediaDevice_StopAndDeAllocate_ParamsDataView input_data_view(params,
                                              context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "MockMediaDevice::StopAndDeAllocate deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "MockMediaDevice::StopAndDeAllocate");
      mojo::internal::MessageDispatchContext context(message);
      impl->StopAndDeAllocate();
      return true;
    }
  }
  return false;
}

// static
bool MockMediaDeviceStubDispatch::AcceptWithResponder(
    MockMediaDevice* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message,
    mojo::MessageReceiverWithStatus* responder) {
  switch (message->header()->name) {
    case internal::kMockMediaDevice_AllocateAndStart_Name: {
      break;
    }
    case internal::kMockMediaDevice_StopAndDeAllocate_Name: {
      break;
    }
  }
  return false;
}

bool MockMediaDeviceRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "MockMediaDevice RequestValidator");

  switch (message->header()->name) {
    case internal::kMockMediaDevice_AllocateAndStart_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::MockMediaDevice_AllocateAndStart_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kMockMediaDevice_StopAndDeAllocate_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::MockMediaDevice_StopAndDeAllocate_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace video_capture

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif