// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "third_party/WebKit/public/platform/modules/shapedetection/shapedetection.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "third_party/WebKit/Source/platform/mojo/KURLStructTraits.h"
#include "third_party/WebKit/public/web/WindowFeaturesStructTraits.h"
#include "third_party/WebKit/public/platform/ReferrerPolicyEnumTraits.h"
#include "third_party/WebKit/Source/platform/mojo/SecurityOriginStructTraits.h"
#include "third_party/WebKit/Source/platform/mojo/CommonCustomTypesStructTraits.h"
#include "third_party/WebKit/Source/platform/mojo/GeometryStructTraits.h"
namespace blink {
namespace mojom {
namespace blink {// static
FaceDetectionResultPtr FaceDetectionResult::New() {
  FaceDetectionResultPtr rv;
  mojo::internal::StructHelper<FaceDetectionResult>::Initialize(&rv);
  return rv;
}

FaceDetectionResult::FaceDetectionResult()
    : boundingBoxes() {
}

FaceDetectionResult::~FaceDetectionResult() {
}// static
BarcodeDetectionResultPtr BarcodeDetectionResult::New() {
  BarcodeDetectionResultPtr rv;
  mojo::internal::StructHelper<BarcodeDetectionResult>::Initialize(&rv);
  return rv;
}

BarcodeDetectionResult::BarcodeDetectionResult()
    : raw_value(),
      bounding_box() {
}

BarcodeDetectionResult::~BarcodeDetectionResult() {
}
size_t BarcodeDetectionResult::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->raw_value);
  seed = mojo::internal::WTFHash(seed, this->bounding_box);
  return seed;
}
const char ShapeDetection::Name_[] = "blink::mojom::ShapeDetection";
const uint32_t ShapeDetection::Version_;

class ShapeDetection_DetectFaces_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ShapeDetection_DetectFaces_ForwardToCallback(
      const ShapeDetection::DetectFacesCallback& callback,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : callback_(callback),
        serialization_context_(std::move(group_controller)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ShapeDetection::DetectFacesCallback callback_;
  mojo::internal::SerializationContext serialization_context_;
  DISALLOW_COPY_AND_ASSIGN(ShapeDetection_DetectFaces_ForwardToCallback);
};
bool ShapeDetection_DetectFaces_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::ShapeDetection_DetectFaces_ResponseParams_Data* params =
      reinterpret_cast<internal::ShapeDetection_DetectFaces_ResponseParams_Data*>(
          message->mutable_payload());
  
  (&serialization_context_)->handles.Swap((message)->mutable_handles());
  bool success = true;
  FaceDetectionResultPtr p_result{};
  ShapeDetection_DetectFaces_ResponseParamsDataView input_data_view(params,
                                          &serialization_context_);
  
  if (!input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ShapeDetection::DetectFaces response deserializer");
    return false;
  }
  if (!callback_.is_null()) {
    mojo::internal::MessageDispatchContext context(message);
    callback_.Run(
std::move(p_result));
  }
  return true;
}

class ShapeDetection_DetectBarcodes_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ShapeDetection_DetectBarcodes_ForwardToCallback(
      const ShapeDetection::DetectBarcodesCallback& callback,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : callback_(callback),
        serialization_context_(std::move(group_controller)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ShapeDetection::DetectBarcodesCallback callback_;
  mojo::internal::SerializationContext serialization_context_;
  DISALLOW_COPY_AND_ASSIGN(ShapeDetection_DetectBarcodes_ForwardToCallback);
};
bool ShapeDetection_DetectBarcodes_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::ShapeDetection_DetectBarcodes_ResponseParams_Data* params =
      reinterpret_cast<internal::ShapeDetection_DetectBarcodes_ResponseParams_Data*>(
          message->mutable_payload());
  
  (&serialization_context_)->handles.Swap((message)->mutable_handles());
  bool success = true;
  WTF::Vector<BarcodeDetectionResultPtr> p_results{};
  ShapeDetection_DetectBarcodes_ResponseParamsDataView input_data_view(params,
                                          &serialization_context_);
  
  if (!input_data_view.ReadResults(&p_results))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ShapeDetection::DetectBarcodes response deserializer");
    return false;
  }
  if (!callback_.is_null()) {
    mojo::internal::MessageDispatchContext context(message);
    callback_.Run(
std::move(p_results));
  }
  return true;
}

ShapeDetectionProxy::ShapeDetectionProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ShapeDetectionProxy::DetectFaces(
    mojo::ScopedSharedBufferHandle in_frame_data, uint32_t in_width, uint32_t in_height, const DetectFacesCallback& callback) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::blink::mojom::internal::ShapeDetection_DetectFaces_Params_Data);
  mojo::internal::RequestMessageBuilder builder(internal::kShapeDetection_DetectFaces_Name, size);

  auto params =
      ::blink::mojom::internal::ShapeDetection_DetectFaces_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_frame_data, &params->frame_data, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->frame_data),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid frame_data in ShapeDetection.DetectFaces request");
  params->width = in_width;
  params->height = in_height;
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  mojo::MessageReceiver* responder =
      new ShapeDetection_DetectFaces_ForwardToCallback(
          callback, group_controller_);
  if (!receiver_->AcceptWithResponder(builder.message(), responder))
    delete responder;
}

void ShapeDetectionProxy::DetectBarcodes(
    mojo::ScopedSharedBufferHandle in_frame_data, uint32_t in_width, uint32_t in_height, const DetectBarcodesCallback& callback) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::blink::mojom::internal::ShapeDetection_DetectBarcodes_Params_Data);
  mojo::internal::RequestMessageBuilder builder(internal::kShapeDetection_DetectBarcodes_Name, size);

  auto params =
      ::blink::mojom::internal::ShapeDetection_DetectBarcodes_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_frame_data, &params->frame_data, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->frame_data),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid frame_data in ShapeDetection.DetectBarcodes request");
  params->width = in_width;
  params->height = in_height;
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  mojo::MessageReceiver* responder =
      new ShapeDetection_DetectBarcodes_ForwardToCallback(
          callback, group_controller_);
  if (!receiver_->AcceptWithResponder(builder.message(), responder))
    delete responder;
}
class ShapeDetection_DetectFaces_ProxyToResponder {
 public:
  static ShapeDetection::DetectFacesCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController>
          group_controller) {
    std::unique_ptr<ShapeDetection_DetectFaces_ProxyToResponder> proxy(
        new ShapeDetection_DetectFaces_ProxyToResponder(
            request_id, is_sync, responder, group_controller));
    return base::Bind(&ShapeDetection_DetectFaces_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ShapeDetection_DetectFaces_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ShapeDetection::DetectFaces() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
  }

 private:
  ShapeDetection_DetectFaces_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(responder),
        serialization_context_(std::move(group_controller)) {
  }

  void Run(
      FaceDetectionResultPtr in_result);

  uint64_t request_id_;
  bool is_sync_;
  mojo::MessageReceiverWithStatus* responder_;
  // TODO(yzshen): maybe I should use a ref to the original one?
  mojo::internal::SerializationContext serialization_context_;

  DISALLOW_COPY_AND_ASSIGN(ShapeDetection_DetectFaces_ProxyToResponder);
};

void ShapeDetection_DetectFaces_ProxyToResponder::Run(
    FaceDetectionResultPtr in_result) {
  size_t size = sizeof(::blink::mojom::internal::ShapeDetection_DetectFaces_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::blink::mojom::FaceDetectionResultDataView>(
      in_result, &serialization_context_);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kShapeDetection_DetectFaces_Name, size, request_id_,
      is_sync_ ? mojo::Message::kFlagIsSync : 0);
  auto params =
      ::blink::mojom::internal::ShapeDetection_DetectFaces_ResponseParams_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->result)::BaseType* result_ptr;
  mojo::internal::Serialize<::blink::mojom::FaceDetectionResultDataView>(
      in_result, builder.buffer(), &result_ptr, &serialization_context_);
  params->result.Set(result_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->result.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null result in ShapeDetection.DetectFaces response");
  (&serialization_context_)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = responder_->Accept(builder.message());
  ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class ShapeDetection_DetectBarcodes_ProxyToResponder {
 public:
  static ShapeDetection::DetectBarcodesCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController>
          group_controller) {
    std::unique_ptr<ShapeDetection_DetectBarcodes_ProxyToResponder> proxy(
        new ShapeDetection_DetectBarcodes_ProxyToResponder(
            request_id, is_sync, responder, group_controller));
    return base::Bind(&ShapeDetection_DetectBarcodes_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ShapeDetection_DetectBarcodes_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ShapeDetection::DetectBarcodes() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
  }

 private:
  ShapeDetection_DetectBarcodes_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(responder),
        serialization_context_(std::move(group_controller)) {
  }

  void Run(
      WTF::Vector<BarcodeDetectionResultPtr> in_results);

  uint64_t request_id_;
  bool is_sync_;
  mojo::MessageReceiverWithStatus* responder_;
  // TODO(yzshen): maybe I should use a ref to the original one?
  mojo::internal::SerializationContext serialization_context_;

  DISALLOW_COPY_AND_ASSIGN(ShapeDetection_DetectBarcodes_ProxyToResponder);
};

void ShapeDetection_DetectBarcodes_ProxyToResponder::Run(
    WTF::Vector<BarcodeDetectionResultPtr> in_results) {
  size_t size = sizeof(::blink::mojom::internal::ShapeDetection_DetectBarcodes_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<mojo::ArrayDataView<::blink::mojom::BarcodeDetectionResultDataView>>(
      in_results, &serialization_context_);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kShapeDetection_DetectBarcodes_Name, size, request_id_,
      is_sync_ ? mojo::Message::kFlagIsSync : 0);
  auto params =
      ::blink::mojom::internal::ShapeDetection_DetectBarcodes_ResponseParams_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->results)::BaseType* results_ptr;
  const mojo::internal::ContainerValidateParams results_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::BarcodeDetectionResultDataView>>(
      in_results, builder.buffer(), &results_ptr, &results_validate_params,
      &serialization_context_);
  params->results.Set(results_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->results.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null results in ShapeDetection.DetectBarcodes response");
  (&serialization_context_)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = responder_->Accept(builder.message());
  ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}

// static
bool ShapeDetectionStubDispatch::Accept(
    ShapeDetection* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kShapeDetection_DetectFaces_Name: {
      break;
    }
    case internal::kShapeDetection_DetectBarcodes_Name: {
      break;
    }
  }
  return false;
}

// static
bool ShapeDetectionStubDispatch::AcceptWithResponder(
    ShapeDetection* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message,
    mojo::MessageReceiverWithStatus* responder) {
  switch (message->header()->name) {
    case internal::kShapeDetection_DetectFaces_Name: {
      internal::ShapeDetection_DetectFaces_Params_Data* params =
          reinterpret_cast<internal::ShapeDetection_DetectFaces_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      mojo::ScopedSharedBufferHandle p_frame_data{};
      uint32_t p_width{};
      uint32_t p_height{};
      ShapeDetection_DetectFaces_ParamsDataView input_data_view(params,
                                              context);
      
      p_frame_data = input_data_view.TakeFrameData();
      p_width = input_data_view.width();
      p_height = input_data_view.height();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ShapeDetection::DetectFaces deserializer");
        return false;
      }
      ShapeDetection::DetectFacesCallback callback =
          ShapeDetection_DetectFaces_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync), responder,
              context->group_controller);
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "ShapeDetection::DetectFaces");
      mojo::internal::MessageDispatchContext context(message);
      impl->DetectFaces(
std::move(p_frame_data), 
std::move(p_width), 
std::move(p_height), callback);
      return true;
    }
    case internal::kShapeDetection_DetectBarcodes_Name: {
      internal::ShapeDetection_DetectBarcodes_Params_Data* params =
          reinterpret_cast<internal::ShapeDetection_DetectBarcodes_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      mojo::ScopedSharedBufferHandle p_frame_data{};
      uint32_t p_width{};
      uint32_t p_height{};
      ShapeDetection_DetectBarcodes_ParamsDataView input_data_view(params,
                                              context);
      
      p_frame_data = input_data_view.TakeFrameData();
      p_width = input_data_view.width();
      p_height = input_data_view.height();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ShapeDetection::DetectBarcodes deserializer");
        return false;
      }
      ShapeDetection::DetectBarcodesCallback callback =
          ShapeDetection_DetectBarcodes_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync), responder,
              context->group_controller);
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "ShapeDetection::DetectBarcodes");
      mojo::internal::MessageDispatchContext context(message);
      impl->DetectBarcodes(
std::move(p_frame_data), 
std::move(p_width), 
std::move(p_height), callback);
      return true;
    }
  }
  return false;
}

bool ShapeDetectionRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "ShapeDetection RequestValidator");

  switch (message->header()->name) {
    case internal::kShapeDetection_DetectFaces_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ShapeDetection_DetectFaces_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kShapeDetection_DetectBarcodes_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ShapeDetection_DetectBarcodes_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool ShapeDetectionResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "ShapeDetection ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kShapeDetection_DetectFaces_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ShapeDetection_DetectFaces_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kShapeDetection_DetectBarcodes_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ShapeDetection_DetectBarcodes_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


// static
bool StructTraits<::blink::mojom::blink::FaceDetectionResult::DataView, ::blink::mojom::blink::FaceDetectionResultPtr>::Read(
    ::blink::mojom::blink::FaceDetectionResult::DataView input,
    ::blink::mojom::blink::FaceDetectionResultPtr* output) {
  bool success = true;
  ::blink::mojom::blink::FaceDetectionResultPtr result(::blink::mojom::blink::FaceDetectionResult::New());
  
      if (!input.ReadBoundingboxes(&result->boundingBoxes))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::blink::BarcodeDetectionResult::DataView, ::blink::mojom::blink::BarcodeDetectionResultPtr>::Read(
    ::blink::mojom::blink::BarcodeDetectionResult::DataView input,
    ::blink::mojom::blink::BarcodeDetectionResultPtr* output) {
  bool success = true;
  ::blink::mojom::blink::BarcodeDetectionResultPtr result(::blink::mojom::blink::BarcodeDetectionResult::New());
  
      if (!input.ReadRawValue(&result->raw_value))
        success = false;
      if (!input.ReadBoundingBox(&result->bounding_box))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif